//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.access.api_1_svw_invl;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.access.*;
import sim.toolkit.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;


public class API_1_SVW_INVL_1 extends TestToolkitApplet {

    private static SIMView theSimView;

    public static byte[] resp = new byte[1];
    public static byte[] incr = new byte[1];

    /**
     * The Constructor registers the application for the Event.
     */
    private API_1_SVW_INVL_1() {
        
        // Get a reference to the SIM View.
        theSimView = SIMSystem.getTheSIMView();
        
    }

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        API_1_SVW_INVL_1 testApp = new API_1_SVW_INVL_1();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }

    /**
     * This method will be used to trigger the tests.
     * The application will be triggered by an Formatted SMS PP download event.
     * @param event 
     */
    public void processToolkit (byte event) throws ToolkitException {
        EnvelopeHandler envHdlr;
        short result = 0;
        short incrOffset;
        short respOffset;
    
        if (event == EVENT_FORMATTED_SMS_PP_ENV) {

            /*------------------------------------------------------------------
             * TEST CASE 01: No EF is selected
             *----------------------------------------------------------------*/
            try {
                theSimView.invalidate();
                reportTestFailure((byte)TestConstants.TESTCASE01);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE01, 
                        sve.getReason() == SIMViewException.NO_EF_SELECTED);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE01);
            }
        
            /*------------------------------------------------------------------
             * TEST CASE 02: Invalidate EF
             *----------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_DF_SIMTEST);
                theSimView.select(TestConstants.FID_EF_TNR);

                theSimView.invalidate();

                theSimView.rehabilitate();
                reportTestSuccess((byte)TestConstants.TESTCASE02);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE02);
            }

            /*------------------------------------------------------------------
             * TEST CASE 03: Access condition not fulfilled
             *----------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_CNIV);

                theSimView.invalidate();
                reportTestFailure((byte)TestConstants.TESTCASE03);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE03, 
                        sve.getReason() == SIMViewException.AC_NOT_FULFILLED);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE03);
            }

            /*------------------------------------------------------------------
             * TEST CASE 04: EF is already invalidated
             *----------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_TNR);

                theSimView.invalidate();

                theSimView.invalidate();

                reportTestFailure((byte)TestConstants.TESTCASE04);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE04, 
                        sve.getReason() == SIMViewException.INVALIDATION_STATUS_CONTRADICTION);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE04);
            }

        } // end if
    }
}
