//-----------------------------------------------------------------------------
//    fwk_csm_proc_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_csm_proc;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Concatenated SMS
 *
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */

public class FWK_CSM_PROC_1 extends TestToolkitApplet {

   private byte testCaseNb = (byte) 0x00;
   private boolean bRes = false;
   private byte nbTriggering = 0;
   short securedDataOffset = 0;
   short SMS1Length = 0x006E;
   final byte[] SMS_TPDID = {(byte)0x82, (byte)0x02, (byte)0x83, (byte)0x81};
   final byte[] SMS1_TPSCA= {(byte)0x06, (byte)0x05, (byte)0x80, (byte)0x11, (byte)0x22, (byte)0x33, (byte)0x44};
   final byte[] SMS1_TPDU = {(byte)0x8B, (byte)0x61, (byte)0x40, (byte)0x02, (byte)0x81, (byte)0x55, (byte)0x7F, (byte)0xF6,
                             (byte)0x00, (byte)0x11, (byte)0x29, (byte)0x12, (byte)0x00, (byte)0x00, (byte)0x04, (byte)0x53, 
                             (byte)0x02, (byte)0x70, (byte)0x00, (byte)0x00, (byte)0x4E, (byte)0x0D, (byte)0x08, (byte)0x00, 
                             (byte)0x00, (byte)0x00, (byte)0x4B, (byte)0x04, (byte)0x24, (byte)0x00, (byte)0x00, (byte)0x00, 
                             (byte)0x00, (byte)0x01, (byte)0x00, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, 
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, 
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA,
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA,
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB,
                             (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB,
                             (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB,
                             (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB,
                             (byte)0xBB, (byte)0xBB, (byte)0xBB};
   final byte[] SMS2_TPSCA= {(byte)0x06, (byte)0x06, (byte)0x80, (byte)0x12, (byte)0x23, (byte)0x34, (byte)0x45, (byte)0x56};
   final byte[] SMS3_TPElt= {(byte)0x40, (byte)0x02, (byte)0x81, (byte)0x55, (byte)0x7F, (byte)0xF6, (byte)0x01, (byte)0x02,
                             (byte)0x03, (byte)0x04, (byte)0x05, (byte)0x06, (byte)0x07}; 
   final byte[] SMS4_DCS  = {(byte)0x19};
   final byte[] SMS4_Data = {(byte)0x48, (byte)0x66, (byte)0x6C, (byte)0x6C, (byte)0x6F, (byte)0x20, (byte)0x48, (byte)0x66,
                             (byte)0x6C, (byte)0x6C, (byte)0x6F, (byte)0x20, (byte)0x48, (byte)0x66, (byte)0x6C, (byte)0x6C,
                             (byte)0x6F, (byte)0x20, (byte)0x48, (byte)0x66, (byte)0x6C, (byte)0x6C, (byte)0x6F, (byte)0x20,
                             (byte)0x48, (byte)0x66, (byte)0x6C, (byte)0x6C, (byte)0x6F, (byte)0x20, (byte)0x21, (byte)0x21,
                             (byte)0x21};
   short SMS5Length = 0x005C;
   final byte[] SMS5_TPSCA= {(byte)0x06, (byte)0x05, (byte)0x80, (byte)0x11, (byte)0x22, (byte)0x33, (byte)0x44};
   final byte[] SMS5_TPDU1= {(byte)0x8B, (byte)0x4E, (byte)0x40, (byte)0x02, (byte)0x81, (byte)0x55, (byte)0x7F, (byte)0xF6,
                             (byte)0x00, (byte)0x11, (byte)0x29, (byte)0x12, (byte)0x00, (byte)0x00, (byte)0x04, (byte)0x40};
   final byte[] SMS5_TPDU2= {(byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA,
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA,
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA,
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA,
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA,
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA,
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA,
                             (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA, (byte)0xAA};
   final byte[] SMS6_TPSCA= {(byte)0x06, (byte)0x06, (byte)0x80, (byte)0x12, (byte)0x23, (byte)0x34, (byte)0x45, (byte)0x56};
   final byte[] SMS7_TPElt= {(byte)0x02, (byte)0x81, (byte)0x55, (byte)0x7F, (byte)0xF6, (byte)0x01, (byte)0x02, (byte)0x03,
                             (byte)0x04, (byte)0x05, (byte)0x06, (byte)0x07}; 
   final byte[] SMS8_DCS  = {(byte)0x1A};
   

   //Constructor of the applet
   public FWK_CSM_PROC_1() {
      //Registration to EVENT_UNFORMATTED_SMS_PP_ENV
      obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
   }


   //Method called by the JCRE at the installation of the applet
   public static void install (byte bArray[], short bOffset, byte bLength){
      //Create a new applet instace
      FWK_CSM_PROC_1 thisApplet = new FWK_CSM_PROC_1();
      // Register the new applet instance to the JCRE
      thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
      // Initialise the data of the test applet 
      thisApplet.init();
   }

   //Method called by the SIM Toolkit Framework
   public void processToolkit(byte event){
   
      nbTriggering++;
      EnvelopeHandler envHdlr = null;
      
      switch (nbTriggering) {
         case 1:
            // Initialise testcase 1 (gathered with 12)
            bRes = true;
            testCaseNb = (byte) 0x01;
            reportTestOutcome(testCaseNb,bRes);

            // Testcase 2: The applet is triggered
            bRes = true;
            testCaseNb = (byte) 0x02;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 3: getTheHandler()
            bRes = false;
            try {
               envHdlr = EnvelopeHandler.getTheHandler() ;
               bRes = true;
            }
            catch (Exception e) {    
               bRes = false ;
            }
            testCaseNb = (byte) 0x03;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 4: check the handler
            // ---Check the length
            try {
               if (SMS1Length == envHdlr.getLength()) {
                  bRes = true;
               }
               else {
                  bRes = false;
               }
            }
            catch (Exception e) {
               bRes = false;
            }
            testCaseNb = (byte) 0x04;
            reportTestOutcome(testCaseNb,bRes);
            //---check the presence and content of each TLV
            bRes = false;
            try {
               // DevId
               if (envHdlr.findTLV(TAG_DEVICE_IDENTITIES, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes = false;
               }
               else {
                  if (envHdlr.compareValue((byte)0x00, SMS_TPDID, (byte)0x02, (byte)0x02) == 0) {
                     bRes = true;
                  }
                  else {
                     bRes = false;
                  }
               }
               // Address
               if (envHdlr.findTLV(TAG_ADDRESS, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes &= false;
               }
               else {
                  if (envHdlr.compareValue((byte)0x00, SMS1_TPSCA, (byte)0x02, (byte)0x05) == 0) {
                     bRes &= true;
                  }
                  else {
                     bRes &= false;
                  }
               }
               // TP_DU
               if (envHdlr.findTLV(TAG_SMS_TPDU, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes &= false;
               }
               else {
                  if ((envHdlr.compareValue((byte)0x00, SMS1_TPDU, (byte)0x02, (byte)0x0D) == 0) &&
                      (envHdlr.compareValue((byte)0x0E, SMS1_TPDU, (byte)0x10, (byte)0x53) == 0)) {
                     bRes &= true;
                  }
                  else {
                     bRes &= false;
                  }
               }
            }
            catch (Exception e) {
               bRes = false;
            }
            testCaseNb = (byte) 0x05;
            reportTestOutcome(testCaseNb,bRes);
            break;
         case 2:
            // Testcase 5: The applet is triggered
            bRes = true;
            testCaseNb = (byte) 0x06;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 6: getTheHandler()
            bRes = false;
            try {
               envHdlr = EnvelopeHandler.getTheHandler() ;
               bRes = true;
            }
            catch (Exception e) {    
               bRes = false ;
            }
            testCaseNb = (byte) 0x07;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 7: check the TP-SCA
            try {
               // TP_Address
               if (envHdlr.findTLV(TAG_ADDRESS, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes = false;
               }
               else {
                  if (envHdlr.compareValue((byte)0x00, SMS2_TPSCA, (byte)0x02, (byte)0x06) == 0) {
                     bRes = true;
                  }
                  else {
                     bRes = false;
                  }
               }
            }
            catch (Exception e) {
               bRes = false;
            }
            testCaseNb = (byte) 0x08;
            reportTestOutcome(testCaseNb,bRes);
            break;
         case 3:
            // Testcase 8: The applet is triggered
            bRes = true;
            testCaseNb = (byte) 0x09;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 9: getTheHandler()
            bRes = false;
            try {
               envHdlr = EnvelopeHandler.getTheHandler() ;
               bRes = true;
            }
            catch (Exception e) {    
               bRes = false ;
            }
            testCaseNb = (byte) 0x0A;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 10: check the TP-elements
            try {
               if (envHdlr.findTLV(TAG_SMS_TPDU, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes = false;
               }
               else {
                  if (envHdlr.compareValue((byte)0x00, SMS3_TPElt, (byte)0x00, (byte)0x0D) == 0) {
                     bRes = true;
                  }
                  else {
                     bRes = false;
                  }
               }
            }
            catch (Exception e) {
               bRes = false;
            }
            testCaseNb = (byte) 0x0B;
            reportTestOutcome(testCaseNb,bRes);
            break;
         case 4:
            // Testcase 11: the applet is triggered with uncompressed 8 bits data
            bRes = true;
            testCaseNb = (byte) 0x0C;
            reportTestOutcome(testCaseNb,bRes);
            
            // Check of the data
            try {
               envHdlr = EnvelopeHandler.getTheHandler() ;
               securedDataOffset = envHdlr.getSecuredDataOffset();
               // check the data
               if (envHdlr.compareValue(securedDataOffset, SMS4_Data, (short)0x00, (short)0x21) == 0) {
                  bRes = true;
               }
               else {
                  bRes = false;
               }
               // check the DCS
               if (envHdlr.compareValue((byte)0x05, SMS4_DCS, (short)0x00, (short)0x01) == 0) {
                  bRes &= true;
               }
               else {
                  bRes &= false;
               }               
            }
            catch (Exception e) {    
               bRes = true ;
            }
            testCaseNb = (byte) 0x0D;
            reportTestOutcome(testCaseNb,bRes);
            break;
         case 5:
            // Testcase 12 is dealed with testcase 1 in the default section.
            
            // Testcase 13: the applet is triggered by an unformatted concatenated SMS 
            bRes = true;
            testCaseNb = (byte) 0x0E;
            reportTestOutcome(testCaseNb,bRes);
            // Testcase 14: getTheHandler()
            bRes = false;
            try {
               envHdlr = EnvelopeHandler.getTheHandler() ;
               bRes = true;
            }
            catch (Exception e) {    
               bRes = false ;
            }
            testCaseNb = (byte) 0x0F;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 15: check the handler
            // ---Check the length
            try {
               if (SMS5Length >= envHdlr.getLength()) {
                  bRes = true;
               }
               else {
                  bRes = false;
               }
            }
            catch (Exception e) {
               bRes = false;
            }
            testCaseNb = (byte) 0x10;
            reportTestOutcome(testCaseNb,bRes);
            
            //---check the presence and content of each TLV
            bRes = false;
            try {
               // DevId
               if (envHdlr.findTLV(TAG_DEVICE_IDENTITIES, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes = false;
               }
               else {
                  if (envHdlr.compareValue((byte)0x00, SMS_TPDID, (byte)0x02, (byte)0x02) == 0) {
                     bRes = true;
                  }
                  else {
                     bRes = false;
                  }
               }
               // Address
               if (envHdlr.findTLV(TAG_ADDRESS, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes &= false;
               }
               else {
                  if (envHdlr.compareValue((byte)0x00, SMS5_TPSCA, (byte)0x02, (byte)0x05) == 0) {
                     bRes &= true;
                  }
                  else {
                     bRes &= false;
                  }
               }
               // TP_DU
               if (envHdlr.findTLV(TAG_SMS_TPDU, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes &= false;
               }
               else {
                  if ((envHdlr.compareValue((byte)0x01, SMS5_TPDU1, (byte)0x03, (byte)0x0C) == 0) &&
                      (envHdlr.compareValue((byte)0x0F, SMS5_TPDU2, (byte)0x00, (byte)0x3F) == 0)) {
                     bRes &= true;
                  }
                  else {
                     bRes &= false;
                  }
               }
            }
            catch (Exception e) {
               bRes = false;
            }
            testCaseNb = (byte) 0x11;
            reportTestOutcome(testCaseNb,bRes);
            break;
         case 6:
            // Testcase 16: The applet is triggered
            bRes = true;
            testCaseNb = (byte) 0x12;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 17: getTheHandler()
            bRes = false;
            try {
               envHdlr = EnvelopeHandler.getTheHandler() ;
               bRes = true;
            }
            catch (Exception e) {    
               bRes = false ;
            }
            testCaseNb = (byte) 0x13;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 18: check the TP-SCA
            try {
               // TP_Address
               if (envHdlr.findTLV(TAG_ADDRESS, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes = false;
               }
               else {
                  if (envHdlr.compareValue((byte)0x00, SMS6_TPSCA, (byte)0x02, (byte)0x06) == 0) {
                     bRes = true;
                  }
                  else {
                     bRes = false;
                  }
               }
            }
            catch (Exception e) {
               bRes = false;
            }
            testCaseNb = (byte) 0x14;
            reportTestOutcome(testCaseNb,bRes);
            break;
         case 7:
            // Testcase 19: The applet is triggered
            bRes = true;
            testCaseNb = (byte) 0x15;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 20: getTheHandler()
            bRes = false;
            try {
               envHdlr = EnvelopeHandler.getTheHandler() ;
               bRes = true;
            }
            catch (Exception e) {    
               bRes = false ;
            }
            testCaseNb = (byte) 0x16;
            reportTestOutcome(testCaseNb,bRes);
            
            // Testcase 21: check the TP-elements
            try {
               if (envHdlr.findTLV(TAG_SMS_TPDU, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes = false;
               }
               else {
                  if (envHdlr.compareValue((byte)0x01, SMS7_TPElt, (byte)0x00, (byte)0x0C) == 0) {
                     bRes = true;
                  }
                  else {
                     bRes = false;
                  }
               }
            }
            catch (Exception e) {
               bRes = false;
            }
            testCaseNb = (byte) 0x17;
            reportTestOutcome(testCaseNb,bRes);
            break;
         case 8:
            // Testcase 22: the applet is triggered with uncompressed UCS2 data
            bRes = true;
            testCaseNb = (byte) 0x18;
            reportTestOutcome(testCaseNb,bRes);
            
            try {
               // check the DCS
               envHdlr = EnvelopeHandler.getTheHandler() ;
               if (envHdlr.findTLV(TAG_SMS_TPDU, (byte) 0x01) == TLV_NOT_FOUND) {
                  bRes = false;
               }
               else {
                   if (envHdlr.compareValue((byte)0x05, SMS8_DCS, (short)0x00, (short)0x01) == 0) {
                      bRes = true;
                   }
                   else {
                      bRes = false;
                   }               
               }
            }
            catch (Exception e) {    
               bRes = false ;
            }
            testCaseNb = (byte) 0x19;
            reportTestOutcome(testCaseNb,bRes);
            break;
         default:
            // Testcases 1 and 12 : the applet is triggered only once all the 
            //   segments of the concatenated SMS are recieved
            bRes=false;
            testCaseNb = 1;
            reportTestOutcome(testCaseNb,bRes);
      }      
   }
}
