//-----------------------------------------------------------------------------
//    FWK_TIN_ACDO_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_tin_acdo;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;
import sim.access.*;
//import sim.test.access.*;

/**
 * Test Area : Framework_ToolkitInstallation_AccessDomain(byte event) method
 * 
 * Applet is triggered on Install (Install), EVENT_MENU_SELECTION
 *
 * @version 0.0.1 - 20/09/01
 *
 */
public class FWK_TIN_ACDO_1 extends TestToolkitApplet //implements TestConstants
{ 
	private SIMView obSim;

	/**
     * Constructor of the applet
     */
	
	public FWK_TIN_ACDO_1()
	{
		// Get a reference to the SIM View.
        obSim = SIMSystem.getTheSIMView();

	} 

	/**
     * Method called by the JCRE at the installation of the applet
     */
	public static void install(byte bArray[], short bOffset, byte bLength)
	{
		// Create a new applet instance
		FWK_TIN_ACDO_1 thisApplet = new FWK_TIN_ACDO_1();

		// Register the new applet instance to the JCRE
		thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

		// Initialise the data of the test applet
		thisApplet.init();
		
		// register instance with the EVENT_UNFORMATTED_SMS_PP_ENV event
		thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
	}

    /**
     * Method called by the SIM Toolkit Framework
     */
	public void processToolkit(byte event)
	{
		boolean bRes = true;
		byte	bTestCaseNb = (byte)0;
		byte	abRead[] = new byte[3];
		byte	abIncreaseValue[] = new byte [3];

		// initializing EF_IMSI file as invalidate state 
		try {
			obSim.select(SIMView.FID_DF_GSM);
			obSim.select(SIMView.FID_EF_IMSI);
			obSim.invalidate();
		}

		catch (Exception e) {
		}

		if (event == EVENT_UNFORMATTED_SMS_PP_ENV) {
			
			// -----------------------------------------------------------------
			//	Test Case 1 :		1-  Select EF_TARU
			//							readBinary() with paramaters
			//							fileOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							respLength = 3
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)1;
			bRes = true;

			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_TARU);

			try {
				obSim.readBinary((short)0, abRead, (short)0, (short)3);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );
			
			// -----------------------------------------------------------------
			//						2-  Select EF_SMS
			//							readRecord() with paramaters
			//							fileOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							respLength = 3
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)2;
			bRes = true;
			
			obSim.select(SIMView.FID_DF_TELECOM);
			obSim.select(SIMView.FID_EF_SMS);

			try {
				obSim.readRecord((short)1, SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT, (short)0, abRead, (short)0, (short)3);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						3-  Select EF_TRAC
			//							readBinary() with paramaters
			//							fileOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							respLength = 3
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)3;
			bRes = true;

			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_TRAC);

			try {
				obSim.readBinary((short)0, abRead, (short)0, (short)3);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						4-	Select EF_SUME
			//							readBinary() with paramaters
			//							fileOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							respLength = 3
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)4;
			bRes = true;
			
			obSim.select(SIMView.FID_DF_GSM);
			obSim.select(SIMView.FID_EF_SUME);

			try {
				obSim.readBinary((short)0, abRead, (short)0, (short)3);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						5-	Select EF_TNR
			//							readBinary() with paramaters
			//							fileOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							respLength = 3
			//							Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)5;
			bRes = false;
			
			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_TNR);

			try {
				obSim.readBinary((short)0, abRead, (short)0, (short)3);
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//	Test Case 2 :		1-  Select EF_TNR
			//							updateBinary() with paramaters
			//							fileOffset = 0
			//							resp = abRead[AAAAAA]
			//							respOffset = 0
			//							respLength = 3
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)6;
			bRes = true;

			abRead[0]=(byte)0xaa;
			abRead[1]=(byte)0xaa;
			abRead[2]=(byte)0xaa;

			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_TNR);

			try {
				obSim.updateBinary((short)0, abRead, (short)0, (short)3);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );
			
			// -----------------------------------------------------------------
			//						2-  Select EF_SMS
			//							updateRecord() with parameters
			//							recNumber = 1
			//							mode = REC_ACC_MODE_ABSOLUTE_CURRENT
			//							recOffset = 0
			//							data = abRead[00FFFF]
			//							dataOffset = 0
			//							dataLength = 3
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)7;
			bRes = true;

			abRead[0]=(byte)0x00;
			abRead[1]=(byte)0xff;
			abRead[2]=(byte)0xff;

			
			obSim.select(SIMView.FID_DF_TELECOM);
			obSim.select(SIMView.FID_EF_SMS);

			try {
				obSim.updateRecord((short)1, SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT, (short)0, abRead, (short)0, (short)3);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						3-  Select EF_FDN
			//							updateRecord() with parameters
			//							recNumber = 1
			//							mode = REC_ACC_MODE_ABSOLUTE_CURRENT
			//							recOffset = 0
			//							data = abRead[FFFFFF]
			//							dataOffset = 0
			//							dataLength = 3
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)8;
			bRes = true;

			abRead[0]=(byte)0xff;
			abRead[1]=(byte)0xff;
			abRead[2]=(byte)0xff;

			obSim.select(SIMView.FID_EF_FDN);

			try {
				obSim.updateRecord((short)1, SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT, (short)0, abRead, (short)0, (short)3);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						4-	Select EF_SUME
			//							updateBinary() with paramaters 
			//							fileOffset = 0
			//							resp = abRead[850C54]
			//							respOffset = 0
			//							respLength = 3
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)9;
			bRes = true;

			abRead[0]=(byte)0x85;
			abRead[1]=(byte)0x0c;
			abRead[2]=(byte)0x54;
			
			obSim.select(SIMView.FID_DF_GSM);
			obSim.select(SIMView.FID_EF_SUME);

			try {
				obSim.updateBinary((short)0, abRead, (short)0, (short)3);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						5-	Select EF_TNU
			//							updateBinary() with paramaters 
			//							fileOffset = 0
			//							resp = abRead[FFFFFF]
			//							respOffset = 0
			//							respLength = 3
			//							Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)10;
			bRes = false;

			abRead[0]=(byte)0xff;
			abRead[1]=(byte)0xff;
			abRead[2]=(byte)0xff;
			
			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_TNU);

			try {
				obSim.updateBinary((short)0, abRead, (short)0, (short)3);
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//	Test Case 3 :		1-  Select EF_TNR
			//							invalidate()
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)11;
			bRes = true;

			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_TNR);

			try {
				obSim.invalidate();
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );
			
			// -----------------------------------------------------------------
			//						2-  Select EF_TIAC
			//							invalidate()
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)12;
			bRes = true;
			
			obSim.select(sim.test.access.TestConstants.FID_EF_TIAC);

			try {
				obSim.invalidate();
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						3-  Select EF_ADN
			//							invalidate()
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)13;
			bRes = true;

			obSim.select(SIMView.FID_DF_TELECOM);
			obSim.select(SIMView.FID_EF_ADN);

			try {
				obSim.invalidate();
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						4-	Select EF_SUME
			//							invalidate()
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)14;
			bRes = true;
			
			obSim.select(SIMView.FID_DF_GSM);
			obSim.select(SIMView.FID_EF_SUME);

			try {
				obSim.invalidate();
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						5-	Select EF_CNIV
			//							invalidate()
			//							respLength = 3
			//							Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)15;
			bRes = false;
			
			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_CNIV);

			try {
				obSim.invalidate();
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//	Test Case 4 :		1-  Select EF_TNR
			//							rehabilitate()
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)16;
			bRes = true;

			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_TNR);

			try {
				obSim.rehabilitate();
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );
			
			// -----------------------------------------------------------------
			//						2-  Select EF_IMSI
			//							rehabilitate()
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)17;
			bRes = true;
			
			obSim.select(SIMView.FID_DF_GSM);
			obSim.select(SIMView.FID_EF_IMSI);

			try {
				obSim.rehabilitate();
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						3-  Select EF_ADN
			//							rehabilitate()
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)18;
			bRes = true;

			obSim.select(SIMView.FID_DF_TELECOM);
			obSim.select(SIMView.FID_EF_ADN);

			try {
				obSim.rehabilitate();
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						4-	Select EF_SUME
			//							rehabilitate()
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)19;
			bRes = true;
			
			obSim.select(SIMView.FID_DF_GSM);
			obSim.select(SIMView.FID_EF_SUME);

			try {
				obSim.rehabilitate();
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						5-	Select EF_ICNRH
			//							rehabilitate()
			//							Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)20;
			bRes = false;
			
			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_CNRI);

			try {
				obSim.rehabilitate();
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//	Test Case 5 :		1-  Select EF_CNR
			//							increase() with paramaters
			//							incr = abIncreaseValue[000000]
			//							incrOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)21;
			bRes = true;

			abIncreaseValue[0]=(byte)0x00;
			abIncreaseValue[1]=(byte)0x00;
			abIncreaseValue[2]=(byte)0x00;

			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_CNR);

			try {
				obSim.increase(abIncreaseValue, (short)0, abRead, (short)0);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );
			
			// -----------------------------------------------------------------
			//						2-  Select EF_ACM
			//							increase() with paramaters 
			//							incr = abIncreaseValue[000000]
			//							incrOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)22;
			bRes = true;
			
			obSim.select(SIMView.FID_DF_GSM);
			obSim.select(SIMView.FID_EF_ACM);

			try {
				obSim.increase(abIncreaseValue, (short)0, abRead, (short)0);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						3-  Select EF_CIAC
			//							increase() with paramaters
			//							incr = abIncreaseValue[000000]
			//							incrOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)23;
			bRes = true;

			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_CIAC);

			try {
				obSim.increase(abIncreaseValue, (short)0, abRead, (short)0);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						4-	Select EF_CIAA
			//							increase() with paramaters
			//							incr = abIncreaseValue[000000]
			//							incrOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							No exception shall be thrown
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)24;
			bRes = true;
			
			obSim.select(sim.test.access.TestConstants.FID_EF_CIAA);

			try {
				obSim.increase(abIncreaseValue, (short)0, abRead, (short)0);
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

			// -----------------------------------------------------------------
			//						5-	Select EF_CNU
			//							increase() with paramaters
			//							incr = abIncreaseValue[000000]
			//							incrOffset = 0
			//							resp = abRead[]
			//							respOffset = 0
			//							Shall throw a ToolkitException.AC_NOT_FULFILLED
			// -----------------------------------------------------------------
			bTestCaseNb = (byte)25;
			bRes = false;
			
			obSim.select(sim.test.access.TestConstants.FID_EF_CNU);

			try {
				obSim.increase(abIncreaseValue, (short)0, abRead, (short)0);
			}

			catch (SIMViewException e) {
				bRes = (e.getReason() == SIMViewException.AC_NOT_FULFILLED) ;
			}

			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome ( bTestCaseNb, bRes );

		}

		// replacing EF_TIAC file in its initial state
		try {
			obSim.select(sim.test.access.TestConstants.FID_DF_SIMTEST);
			obSim.select(sim.test.access.TestConstants.FID_EF_TIAC);
			obSim.rehabilitate();
		}

		catch (Exception e) {
		}

		// initializing EF_SUME file as invalidate state for 2nd applet (no access to GSM File System)
		try {
			obSim.select(SIMView.FID_DF_GSM);
			obSim.select(SIMView.FID_EF_SUME);
			obSim.invalidate();
		}

		catch (Exception e) {
		}


	}
}