//-----------------------------------------------------------------------------
//    FWK_TIN_CHAL_3.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_tin_chal;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.framework Toolkit Installation, Channels Allocation
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class FWK_TIN_CHAL_3 extends TestToolkitApplet {

    // Channel number to open
    final static short CHANNELS_NB = 3;
    
    public final static byte QUALIFIER_1 = (byte)0x01;
    public final static byte QUALIFIER_2 = (byte)0x02;
    public static byte[] ADDRESS_VALUE = {(byte)0x81, (byte)0x55, (byte)0x66, (byte)0x77, (byte)0x88};
    public static byte[] BEARER_VALUE = {(byte)0x03, (byte)0x00};
    public static byte[] BUFFER_SIZE_VALUE = {(byte)0x00, (byte)0x0A};

    /**
     * Constructor of the applet
     */
    public FWK_TIN_CHAL_3() {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) {

        // Create a new applet instance
        FWK_TIN_CHAL_3 thisApplet = new FWK_TIN_CHAL_3();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) {
        
        // Result of each test
        boolean bRes = false ;
        
        // Number of tests
        byte testCaseNb;

        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler();

       
	    if (event == EVENT_FORMATTED_SMS_PP_ENV) {
        	// --------------------------------------------
        	// Test Case 6 : Open 3 channels
        	testCaseNb = (byte) 1 ;

            for (short i=0; i<CHANNELS_NB; i++) {
              	bRes = false ;
                try {
                    proHdlr.init(PRO_CMD_OPEN_CHANNEL, QUALIFIER_1, DEV_ID_ME);
                    proHdlr.appendTLV(TAG_ADDRESS, ADDRESS_VALUE, (short)0, (short)5);
                    proHdlr.appendTLV(TAG_BEARER_DESCRIPTION, BEARER_VALUE, (short)0, (short)2);
                    proHdlr.appendTLV(TAG_BUFFER_SIZE, BUFFER_SIZE_VALUE, (short)0, (short)2);
                    proHdlr.send();
                    bRes = true ;
                }
		        catch (Exception e) {	
			        bRes = false;
		        }
        	    reportTestOutcome(testCaseNb++, bRes) ;
            }

            // Try to Open a 4th channel
            try {
                proHdlr.init(PRO_CMD_OPEN_CHANNEL, QUALIFIER_1, DEV_ID_ME);
                proHdlr.appendTLV(TAG_ADDRESS, ADDRESS_VALUE, (short)0, (short)5);
                proHdlr.appendTLV(TAG_BEARER_DESCRIPTION, BEARER_VALUE, (short)0, (short)2);
                proHdlr.appendTLV(TAG_BUFFER_SIZE, BUFFER_SIZE_VALUE, (short)0, (short)2);
                proHdlr.send();
                bRes = true ;
            }
		    catch (Exception e) {	
			    bRes = false;
		    }
        	reportTestOutcome(testCaseNb, bRes) ;

	    }
    }
}
