//-----------------------------------------------------------------------------
//    FWK_APT_EDMC_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_edmc;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering
 *
 * Applet is triggered on Install (Install, all events
 *
 * @version 0.0.1 - 15/11/01
 *
 */

 public class FWK_APT_EDMC_1 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;
     private static boolean bRes;
     //private static ToolkitRegistry obReg;


    //Constructor of the applet

    public FWK_APT_EDMC_1(){
        //register to EVENT DOWNLOAD MT CALL
       // obReg = ToolkitRegistry.getEntry();
        obReg.setEvent(EVENT_EVENT_DOWNLOAD_MT_CALL);


    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_APT_EDMC_1 thisApplet = new FWK_APT_EDMC_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
        //Checks if the applet is registered to the event
        bRes=thisApplet.obReg.isEventSet(EVENT_EVENT_DOWNLOAD_MT_CALL);
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

        

        if(event==EVENT_EVENT_DOWNLOAD_MT_CALL){

            switch(testCaseNb){

                case (byte)0x00:
                    //TEST CASE 1: Store the result of the test if the applet is registered to the event
                    testCaseNb=(byte)0x01;
                    reportTestOutcome(testCaseNb,bRes);			
                    bRes=false;
                    //TEST CASE 2: The applet has been triggered and it's deregistered to the event
                    testCaseNb=(byte)0x02;
                    try{
                        obReg.clearEvent(EVENT_EVENT_DOWNLOAD_MT_CALL);
                        bRes=true;
                    }
                    catch(Exception e){
                        bRes=false;
                    }
                    reportTestOutcome(testCaseNb,bRes);
		    reportTestOutcome((byte)0x03,true);	
               break;
               case (byte)0x02:
                   //TEST CASE 3: The applet must not be triggered in this case
                   //if the applet is triggered the the test is falled
               	   testCaseNb=(byte)0x03;
               	   bRes=false;
               	   reportTestOutcome(testCaseNb,bRes);
               break;	
               case (byte)0x04:
                   //TEST CASE 5: The applet is triggered
                   testCaseNb=(byte)0x05;
                   bRes=true;
                   reportTestOutcome(testCaseNb,bRes);
            }
        }

        if(event==EVENT_FORMATTED_SMS_PP_ENV){
            //TEST CASE 4: The applet is registered to the Event Download MT Call event
            testCaseNb=(byte)0x04;
            try{
                obReg.setEvent(EVENT_EVENT_DOWNLOAD_MT_CALL);
                bRes=true;
            }
            catch(Exception e){
                bRes=false;
            }
            reportTestOutcome(testCaseNb,bRes);


        }

    }

 }