//-----------------------------------------------------------------------------
//    FWK_APT_EFCA_3.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_efca;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering, EVENT_FIRST_COMMAND_AFTER_SELECT
 *
 * Applet is triggered on EVENT_FORMATTED_SMS_PP_ENV
 *
 *
 */

 public class FWK_APT_EFCA_3 extends TestToolkitApplet {

     private byte testCaseNb = (byte) 0x00;
     private static boolean bRes;
     private byte nbCases =(byte)0x00;
     protected static byte FirstBetweenApp3AndApp4=0;


    // Constructor of the applet
    public FWK_APT_EFCA_3() {
    }


    // Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength) {
        // Create a new applet instance
        FWK_APT_EFCA_3 thisApplet = new FWK_APT_EFCA_3();
        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    // Method called by the SIM Toolkit Framework
    public void processToolkit(byte event) {

        bRes=false;

        switch(nbCases) {
            case (byte)0x00:
                // Test Case 1: The applet is triggered by EVENT_FORMATTED_SMS_PP_ENV
                testCaseNb=(byte)0x01;
                if (event==EVENT_FORMATTED_SMS_PP_ENV) {
                    try{
                        //The applet is registered to the event 	                   
                        obReg.setEvent(EVENT_FIRST_COMMAND_AFTER_SELECT);                    
                        bRes=true;
                    }
                    catch(Exception e){
                        bRes=false;
                    }
                }
                reportTestOutcome(testCaseNb,bRes);
                bRes=false;
                nbCases++;
                break;

            case (byte)0x01:
                // Test Case 2: the applet is triggered by EVENT_FIRST_COMMAND_AFTER_SELECT then...
                testCaseNb=(byte)0x02;
                if (event==EVENT_FIRST_COMMAND_AFTER_SELECT) {
                    try{
                        //The applet is registered to the event 	                   
                        obReg.setEvent(EVENT_PROFILE_DOWNLOAD);                    
                        bRes=true;
                    }
                    catch(Exception e){
                        bRes=false;
                    }
                }
                reportTestOutcome(testCaseNb,bRes);
                bRes=false;
                nbCases++;
                break;

            case (byte)0x02:
                // Test Case 2: by EVENT_PROFILE_DOWNLOAD
                testCaseNb=(byte)0x03;
                if (event==EVENT_PROFILE_DOWNLOAD) {
                    bRes=true;
                } else {
                    bRes=false;
                }
                reportTestOutcome(testCaseNb,bRes);
                bRes=false;
                nbCases++;
                break;


            case (byte)0x03:
                // Test Case 3, 1st result: the applet is triggered by EVENT_FIRST_COMMAND_AFTER_SELECT
                testCaseNb=(byte)0x04;
                if ((event==EVENT_FIRST_COMMAND_AFTER_SELECT) && (FirstBetweenApp3AndApp4 == 1)) {
                    bRes=true;
                    FirstBetweenApp3AndApp4 = 2;
                }
                reportTestOutcome(testCaseNb,bRes);
                bRes=false;
                nbCases++;
                break;

            case (byte)0x04:
                // Test Case 3, 2nd result: the applet is triggered by EVENT_PROFILE_DOWNLOAD
                testCaseNb=(byte)0x05;
                if ((event==EVENT_PROFILE_DOWNLOAD) && (FirstBetweenApp3AndApp4 == 3)) {
                    bRes=true;
                    //FIRST_BETWEEN_APP3_AND_APP4 = 3;
                }
                reportTestOutcome(testCaseNb,bRes);
                break;

        }
    }

 }