//-----------------------------------------------------------------------------
//    FWK_APT_EFSE_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_efse;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering, EVENT_FORMATTED_SMS_PP_ENV
 *
 * Applet is triggered on Install (Install)
 *
 */

 public class FWK_APT_EFSE_1 extends TestToolkitApplet {

     private byte testCaseNb = (byte) 0x00;
     private boolean bRes;
     private static byte[]baMyBuffer = {(byte)0x02, (byte)0x70, (byte)0x00, (byte)0x00, (byte)0x7C};


    // Constructor of the applet
    public FWK_APT_EFSE_1() {
        // register to EVENT_UNRECOGNIZED_ENVELOPE
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);

    }


    // Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength) {

        // Create a new applet instance
        FWK_APT_EFSE_1 thisApplet = new FWK_APT_EFSE_1();
        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    // Method called by the SIM Toolkit Framework
    public void processToolkit(byte event) {

        // Get the system instance of the envelope Handler
        EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();

        if(event==EVENT_FORMATTED_SMS_PP_ENV ) {

            switch(testCaseNb) {
                case (byte)0x00:
            	    // Test Case 1: 1-The applet is triggered by the single message
                    testCaseNb=(byte)0x01;
                    bRes=true;
                    reportTestOutcome(testCaseNb,bRes);
                    testCaseNb=(byte)0x02;
                    break;

                case (byte)0x02:
                    // Test Case 1: 2-The applet is triggered by the concatenated message
                    try {
                        if (envHdlr.findAndCompareValue(TAG_SMS_TPDU,(byte)1,(short)0x11, baMyBuffer, (short)0, (short)baMyBuffer.length)==0) {
                            bRes=true;
                        } else {
                            bRes=false;
                        }
                        // The applet is deregistered to the event
                        obReg.clearEvent(EVENT_FORMATTED_SMS_PP_ENV);
                    }
                    catch(Exception e){
                        bRes=false;
                    }
                    reportTestOutcome(testCaseNb,bRes);
                    testCaseNb=(byte)0x03;
                    // Test Case 2: 1/2-The applet shall not be triggered
                    reportTestOutcome(testCaseNb,true);
                    testCaseNb=(byte)0x04;
                    break;

                case (byte)0x04:
           	    // Test Case 2: 1/2-The applet shall not be triggered           	
           	    // if the applet is triggered the test fails
                    bRes=false;
                    testCaseNb=(byte)0x03;
                    reportTestOutcome(testCaseNb,bRes);
                    testCaseNb=(byte)0x04;
                    break;
		    
                case (byte)0x05:
           	    // Test Case 2: 3-The applet is triggered after the registration to the event by the single message
                    bRes=true;
                    reportTestOutcome(testCaseNb,bRes);
                    testCaseNb=(byte)0x06;
                    break;
                case (byte)0x06:
                // Test Case 2: 4-The applet is triggered by the concatenated message
                    if (envHdlr.findAndCompareValue(TAG_SMS_TPDU,(byte)1,(short)0x11, baMyBuffer, (short)0, (short)baMyBuffer.length)==0) {
                        bRes=true;
                    } else {
                        bRes=false;
                    }
                    reportTestOutcome(testCaseNb,bRes);
                    break;
            }
        }

        if ((event==EVENT_UNRECOGNIZED_ENVELOPE) && (testCaseNb == 0x04)) {
            // Test Case 2: The applet is registered to the event
            try {
                obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
                bRes=true;
            }
            catch(Exception e) {
                bRes=false;
            }
            reportTestOutcome(testCaseNb,bRes);
            testCaseNb=(byte)0x05;
        }
    }
 }