//-----------------------------------------------------------------------------
//    FWK_APT_ESTC_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_estc;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering
 *
 * Applet is triggered on Install (Install, all events
 *
 * @version 0.0.1 - 15/11/01
 *
 */

 public class FWK_APT_ESTC_1 extends TestToolkitApplet{

    private byte testCaseNb = (byte) 0x00;
    private boolean bRes;

    //Constructor of the applet

    public FWK_APT_ESTC_1(){
        //register to EVENT STATUS COMMAND
        obReg.requestPollInterval(POLL_SYSTEM_DURATION);
    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_APT_ESTC_1 thisApplet = new FWK_APT_ESTC_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){
        bRes=false;
        //event STATUS_COMMAND
        switch(testCaseNb){

            case (byte)0x00:
                //TEST CASE 1: THE APPLET IS TRIGGERED
                testCaseNb=(byte)0x01;
                bRes=true;
                reportTestOutcome(testCaseNb,bRes);
           break;

           case (byte)0x01:
                //TEST CASE 2 : THE APPLET IS UNREGISTERED TO THE EVENT
                testCaseNb=(byte)0x02;
               try{
                    //deregister to STATUS_COMMAND
                    obReg.requestPollInterval(POLL_NO_DURATION);
                    bRes=true;
               }
               catch(Exception e){
                    bRes=false;
               }
               reportTestOutcome(testCaseNb,bRes);
               reportTestOutcome((byte)0x03,true);
	   break;
	   case (byte)0x02:
	   	//if the applet is triggered the a 0x00 is stored in the test case 3
                testCaseNb=(byte)0x03;
                reportTestOutcome(testCaseNb,false);

        }

    }
 }