//-----------------------------------------------------------------------------
//    FWK_APT_EUSE_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_euse;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering, EVENT_UNFORMATTED_SMS_PP_ENV
 *
 * Applet is triggered on Install (Install)
 *
 */

 public class FWK_APT_EUSE_1 extends TestToolkitApplet {

     private byte testCaseNb = (byte) 0x00;
     private static boolean bRes;
     private static byte[]baMyBuffer1 = {(byte)0x11, (byte)0x11, (byte)0x11, (byte)0x11, (byte)0x11, (byte)0x11};
     private static byte[]baMyBuffer2 = {(byte)0x33, (byte)0x33, (byte)0x33, (byte)0x33, (byte)0x33, (byte)0x33};


    // Constructor of the applet
    public FWK_APT_EUSE_1(){
       // register to EVENT_UNFORMATTED_SMS_PP_ENV
       obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
    }


    // Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength) {
        // Create a new applet instance
        FWK_APT_EUSE_1 thisApplet = new FWK_APT_EUSE_1();
        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
        // Check if the applet is registered to the event
        bRes=thisApplet.obReg.isEventSet(EVENT_UNFORMATTED_SMS_PP_ENV);
    }


    // Method called by the SIM Toolkit Framework
    public void processToolkit(byte event) {

        // Get the system instance of the envelope Handler
        EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();

        if (event==EVENT_UNFORMATTED_SMS_PP_ENV) {

            switch(testCaseNb) {
                case (byte)0x00:
                    // Test Case 1: 1-This case is to check the applet is registered to the EVENT_UNFORMATTED_SMS_PP_ENV
                    // and          2- is triggered by single EVENT_UNFORMATTED_SMS_PP_ENV envelope
                    testCaseNb=(byte)0x01;
                    bRes=true;
                    reportTestOutcome(testCaseNb,bRes);
                    testCaseNb = (byte) 0x02;
                    break;
                case (byte)0x02:
                    //              2- The applet is triggered by concatenated EVENT_UNFORMATTED_SMS_PP_ENV envelope
                    //                 and is deregistered to the event
                    try {                        
                        if (envHdlr.findAndCompareValue(TAG_SMS_TPDU,(byte)1,(short)0x15, baMyBuffer1, (short)0, (short)baMyBuffer1.length)==0) {
                            bRes=true;
                        } else {
                            bRes=false;
                        }
                        // The applet is deregistered to the event
                        obReg.clearEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
                    }
                    catch (Exception e) {
                        bRes=false;
                    }
                    reportTestOutcome(testCaseNb,bRes);
                    testCaseNb = (byte) 0x03;
                    // Test Case 2: 1/2- The applet must not be triggered in this case
                    reportTestOutcome(testCaseNb,true);
                    testCaseNb = (byte) 0x04;
                    break;

                case (byte)0x04:
                    // Test Case 2: 1/2-The applet must not be triggered in this case
                    // if the applet is triggered then the test fails
                    testCaseNb = (byte) 0x03;
                    bRes=false;
                    reportTestOutcome(testCaseNb,bRes);
                    testCaseNb = (byte) 0x04;
                    break;

                case (byte)0x05:
                    // Test Case 2: 3-The applet is triggered after the registration to the event by the single message
                    bRes=true;
                    reportTestOutcome(testCaseNb,bRes);
                    testCaseNb = (byte) 0x06;
                    break;

                case (byte)0x06:
                    // Test Case 2: 4-The applet is triggered by the concatenated message
                    if (envHdlr.findAndCompareValue(TAG_SMS_TPDU,(byte)1,(short)0x15, baMyBuffer2, (short)0, (short)baMyBuffer2.length)==0) {
                        bRes=true;
                    } else {
                        bRes=false;
                    }
                    reportTestOutcome(testCaseNb,bRes);
                    break;
            }
        }

        if ((event==EVENT_FORMATTED_SMS_PP_ENV) && (testCaseNb == 0x04)) {
            // Test Case 2: The applet is registered to the event
            try {
                obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
                bRes=true;
            }
            catch(Exception e) {
                bRes=false;
            }
            reportTestOutcome(testCaseNb,bRes);
            testCaseNb = (byte) 0x05;
        }
    }
 }