//-----------------------------------------------------------------------------
//    FWK_APT_EUSU_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_eusu;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering, EVENT_FORMATTED_SMS_PP_UPD
 *
 * Applet is triggered on EVENT_FORMATTED_SMS_PP
 *
 */

 public class FWK_APT_EUSU_1 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;
     private static boolean bRes;
     private static byte[]baMyBuffer1 = {(byte)0xBB, (byte)0xBB, (byte)0xBB, (byte)0xBB};
     private static byte[]baMyBuffer2 = {(byte)0xDD, (byte)0xDD, (byte)0xDD, (byte)0xDD};


    // Constructor of the applet
    public FWK_APT_EUSU_1() {
        // register to EVENT_UNRECOGNIZED ENVELOPE
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
        // register to EVENT_UNFORMATTED_SMS_PP_UPD
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);
    }


    // Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength) {

        // Create a new applet instance
        FWK_APT_EUSU_1 thisApplet = new FWK_APT_EUSU_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();
        
        // Test Case 1: 1-is the applet registered to EVENT_UNFORMATTED_SMS_PP_UPD?
        bRes = thisApplet.obReg.isEventSet(EVENT_UNFORMATTED_SMS_PP_UPD);
    }


    // Method called by the SIM Toolkit Framework

    public void processToolkit(byte event) {

        // Get the system instance of the envelope Handler
        EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();

        if (event==EVENT_UNFORMATTED_SMS_PP_UPD) {

            switch(testCaseNb) {
            
            case (byte)0x00:
                // Test Case 1: 1-is the applet registered to EVENT_UNFORMATTED_SMS_PP_UPD?
                testCaseNb=(byte)0x01;
                bRes=true;
                reportTestOutcome(testCaseNb,bRes);
                testCaseNb=(byte)0x02;
                // Test Case 1: 2-The applet is triggered by Update Record EFsms APDU
                bRes=true;
                reportTestOutcome(testCaseNb,bRes);
                testCaseNb=(byte)0x03;
                break;

            case (byte)0x03:
                // Test Case 1: 3- The applet is triggered by Update Record EFsms APDU (concatenated)
                if (envHdlr.findAndCompareValue(TAG_SMS_TPDU,(byte)1,(short)0x15, baMyBuffer1, (short)0, (short)baMyBuffer1.length)==0) {
                        bRes=true;
                    } else {
                        bRes=false;
                    }
                reportTestOutcome(testCaseNb,bRes);
                testCaseNb=(byte)0x04;
                // Test Case 2: The applet is deregistered to EVENT_UNFORMATTED_SMS_PP_UPD
                try {
                    obReg.clearEvent(EVENT_UNFORMATTED_SMS_PP_UPD);
                }
                catch(Exception e){
                    bRes=false;
                }
                reportTestOutcome(testCaseNb,bRes);
                testCaseNb=(byte)0x05;
                //              1/2-The applet is not triggered by EVENT_UNFORMATTED_SMS_PP_UPD
                bRes=true;
                reportTestOutcome(testCaseNb,bRes);
                testCaseNb=(byte)0x06;
                break;

            case (byte)0x06:
            // Test Case 2: 1/2-The applet shall not be triggered           	
           	// if the applet is triggered the test fails
                bRes=false;
                testCaseNb=(byte)0x05;
                reportTestOutcome(testCaseNb,bRes);
                testCaseNb=(byte)0x06;
                break;

            case (byte)0x07:
                // Test Case 2: 3-The applet is triggered by Update Record EFsms APDU
                bRes=true;
                reportTestOutcome(testCaseNb,bRes);
                testCaseNb=(byte)0x08;
                break;

            case (byte)0x08:
                //              4-The applet is triggered by Update Record EFsms APDU (concatenated)
                if (envHdlr.findAndCompareValue(TAG_SMS_TPDU,(byte)1,(short)0x15, baMyBuffer2, (short)0, (short)baMyBuffer2.length)==0) {
                    bRes=true;
                } else {
                    bRes=false;
                }
                reportTestOutcome(testCaseNb,bRes);
                break;
            }
        }

        if ((event==EVENT_UNRECOGNIZED_ENVELOPE) && (testCaseNb==(byte)0x06)){
            try {
                obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);
                bRes=true;
            }
            catch(Exception e){
                bRes=false;
            }
            reportTestOutcome(testCaseNb,bRes);
            testCaseNb=(byte)0x07;
        }

    }
 }