//-----------------------------------------------------------------------------
//    FWK_ERP_ECCN_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_erp_eccn;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;

/**
 * Test Area : sim.toolkit.framework
 *
 * Chapter: Envelope Response Posting
 * Test Area inside the chapter: EVENT_CALL_CONTROL_BY_SIM
 *
 *
 * @version 0.0.1 - 11/12/01
 * @author 3GPP T3 SWG API
 *
 */
public class FWK_ERP_ECCN_1 extends TestToolkitApplet
{
	private static final byte[] DATA2POST = {(byte)0x91, (byte)0x11, (byte)0x22, (byte)0x33, (byte)0x44} ;
	private ToolkitRegistry obReg;


	//	byte testCaseNb = (byte) 0x00;

    /**
     * Constructor of the applet
     */
    public FWK_ERP_ECCN_1() {
		obReg = ToolkitRegistry.getEntry();
		// Triggering on EVENT_CALL_CONTROL_BY_SIM
		obReg.setEvent(EVENT_CALL_CONTROL_BY_SIM);
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength)
    {
		// Create a new applet instance
        FWK_ERP_ECCN_1 thisApplet = new FWK_ERP_ECCN_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();

    }


    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event)
    {
		// Result of each test
		boolean bRes = false;

		// Get the system instance of the EnvelopeHandler class
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();

		// Get the system instance of the EnvelopeResponseHandler class
		EnvelopeResponseHandler envRespHandler = EnvelopeResponseHandler.getTheHandler();

		// EVENT_CALL_CONTROL_BY_SIM :
		// --------------------------------------------
		// The applet changes any incoming dialling number into + 11 22 33 44
		try {
			bRes = false;
			envRespHandler.appendTLV((byte)(TAG_ADDRESS | TAG_SET_CR), DATA2POST, (short)0x00, (short)DATA2POST.length);
	        envRespHandler.postAsBERTLV(SW1_RP_ACK, (byte)0x02);
			bRes = true;
			}
		catch (Exception e)    {
		    bRes = false;
		}
		reportTestOutcome((byte)1, bRes);
	}
}
