//-----------------------------------------------------------------------------
//    FWK_ERP_EFSE_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_erp_efse;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Minimum Handler Integrity
 *
 * Applet is triggered on Install(Install), all events
 *
 *
 */

 public class FWK_ERP_EFSE_1 extends TestToolkitApplet{


	private byte testCaseNb = (byte) 0x00;
	private boolean bRes;
	private static byte[] buffer={(byte)0x16,(byte)0x16,(byte)0x16,(byte)0x16,(byte)0x16,(byte)0x16};
	
	//Constructor of the applet
	public FWK_ERP_EFSE_1(){
		
		testCaseNb = (byte) 0x01;
	}


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_ERP_EFSE_1 thisApplet = new FWK_ERP_EFSE_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init();
    }


	

    //Method called by the SIM Toolkit Framework
	public void processToolkit(byte event){

        switch(testCaseNb){
        	
        	case(byte)1: //	SMS Deliver Report, post with StatusType SW1_RP_ACK
        		
        		try{
        			bRes=true;
        			EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();
        			buffer[0]=(byte)0x01;
        			envRespHdlr.appendArray((byte[])buffer, (short)0, (short)5);
        			envRespHdlr.post(SW1_RP_ACK);
        		}
        		catch (Exception e)	
        		{
        			bRes=false;
        		}
        		reportTestOutcome(testCaseNb,bRes);
        		testCaseNb++;
				break;
				
		case(byte)2: //	SMS Deliver Report, postAsBERTLV with StatusType SW1_RP_ACK
        		
        		try{
        			bRes=true;
        			EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();
        			buffer[0]=(byte)0x02;
        			envRespHdlr.appendArray((byte[])buffer, (short)0, (short)5);
        			envRespHdlr.postAsBERTLV(SW1_RP_ACK, (byte)0x28);
        		}
        		catch (Exception e)	
        		{
        			bRes=false;
        		}
        		reportTestOutcome(testCaseNb,bRes);
				testCaseNb++;
				break;	
				
		case(byte)3: //	SMS Submit, post with StatusType SW1_RP_ACK
        		
        		try{
        			bRes=true;
        			EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();
        			buffer[0]=(byte)0x03;
        			envRespHdlr.appendArray((byte[])buffer, (short)0, (short)5);
        			envRespHdlr.post(SW1_RP_ACK);
        		}
        		catch (Exception e)	
        		{
        			bRes=false;
        		}
        		reportTestOutcome(testCaseNb,bRes);
				testCaseNb++;
				break;
				
		case(byte)4: //	SMS Submit, post with StatusType SW1_RP_ERROR
    		
	    		try{
	    			bRes=true;
	    			EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();
	    			buffer[0]=(byte)0x05;
	    			envRespHdlr.appendArray((byte[])buffer, (short)0, (short)5);
	    			envRespHdlr.post(SW1_RP_ERROR);
	    		}
	    		catch (Exception e)	
	    		{
	    			bRes=false;
	    		}
	    		reportTestOutcome(testCaseNb,bRes);
				testCaseNb++;
				break;

		
		case(byte)5: //	SMS Submit, postAsBERTLV with StatusType SW1_RP_ACK
        		
        		try{
        			bRes=true;
        			EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();
        			buffer[0]=(byte)0x04;
        			envRespHdlr.appendArray((byte[])buffer, (short)0, (short)5);
        			envRespHdlr.postAsBERTLV(SW1_RP_ACK, (byte)0x28);
        		}
        		catch (Exception e)	
        		{
        			bRes=false;
        		}
        		reportTestOutcome(testCaseNb,bRes);
				testCaseNb++;
				break;
				
		
		case(byte)6: //	SMS Submit, postAsBerTLV with StatusType SW1_RP_ERROR
        		
        		try{
        			bRes=true;
        			EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();
        			buffer[0]=(byte)0x06;
        			envRespHdlr.appendArray((byte[])buffer, (short)0, (short)5);
        			envRespHdlr.postAsBERTLV(SW1_RP_ERROR, (byte)0x28);
        		}
        		catch (Exception e)	
        		{
        			bRes=false;
        		}
        		reportTestOutcome(testCaseNb,bRes);
				testCaseNb++;
				break;					
        }	
        
	}
	
}	