//-----------------------------------------------------------------------------
//    FWK_ERP_EMCN_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_erp_emcn;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;

/**
 * Test Area : sim.toolkit.framework
 *
 * Chapter: Envelope Response Posting
 * Test Area inside the chapter: EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
 *
 *
 * @version 0.0.1 - 11/12/01
 * @author 3GPP T3 SWG API
 *
 */
public class FWK_ERP_EMCN_2 extends TestToolkitApplet
{
	private static final byte[] BUFFER = {(byte)'A',(byte)'P',(byte)'P',(byte)'L',(byte)'E',(byte)'T'} ;
	private static final byte WAIT_FOR_USER_TO_CLEAR_MESSAGE = (byte)0x80;
	private static final byte NEXT_ACTION_INDICATOR = (byte)0x00;
	private static final short BEGINNING_OF_STRING = (short)0x00;
	private static byte [] MenuEntry = {(byte) 'T', (byte) 'o', (byte) 'o', (byte) 'l',	(byte) 'k',	(byte) 'i',	(byte) 't',	(byte) 'T', (byte) 'e',	(byte) 's', (byte) 't'};
	private ToolkitRegistry obReg;


	//byte testCaseNb = (byte) 0x00;

    /**
     * Constructor of the applet
     */
    public FWK_ERP_EMCN_2() {
		obReg = ToolkitRegistry.getEntry();

		// Triggering on EVENT_MENU_SELECTION
		obReg.initMenuEntry(MenuEntry, BEGINNING_OF_STRING, (short)MenuEntry.length, NEXT_ACTION_INDICATOR, false, (byte)0, (short)0);
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength)
    {
        // Create a new applet instance
        FWK_ERP_EMCN_2 thisApplet = new FWK_ERP_EMCN_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();

    }


    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event)
    {
		// Result of each test
		boolean bRes = false;

		// Get the system instance of the EnvelopeHandler class
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();

        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;

		// EVENT_MENU_SELECTION :
		// --------------------------------------------
		// The applet prepares and send a Display Text Proactive command with the string "APPLET"
		try {
			bRes = false;
			proHdlr.initDisplayText(WAIT_FOR_USER_TO_CLEAR_MESSAGE, DCS_8_BIT_DATA, BUFFER, BEGINNING_OF_STRING, (short)BUFFER.length) ;
			proHdlr.send();
			bRes = true;
			}
		catch (Exception e)    {
		    bRes = false;
		}
		reportTestOutcome((byte)1, bRes);
	}
}
