//-----------------------------------------------------------------------------
//    FWK_ERP_EMCN_3.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_erp_emcn;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;

/**
 * Test Area : sim.toolkit.framework
 *
 * Chapter: Envelope Response Posting
 * Test Area inside the chapter: EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
 *
 *
 * @version 0.0.1 - 11/12/01
 * @author 3GPP T3 SWG API
 *
 */
public class FWK_ERP_EMCN_3 extends TestToolkitApplet
{
	private static final byte[] BUFFER = {(byte)'A',(byte)'P',(byte)'P',(byte)'L',(byte)'E',(byte)'T'} ;
	private static final byte WAIT_FOR_USER_TO_CLEAR_MESSAGE = (byte)0x80;
	private static final byte NEXT_ACTION_INDICATOR = (byte)0x00;
	private static final short BEGINNING_OF_STRING = (short)0x00;
	private static final byte[] DATA2POST = {(byte)0x91, (byte)0x11, (byte)0x22, (byte)0x33, (byte)0x44} ;
	private static byte [] MenuEntry = {(byte) 'T', (byte) 'o', (byte) 'o', (byte) 'l',	(byte) 'k',	(byte) 'i',	(byte) 't',	(byte) 'T', (byte) 'e',	(byte) 's', (byte) 't'};
	private ToolkitRegistry obReg;

    /**
     * Constructor of the applet
     */
    public FWK_ERP_EMCN_3() {
		obReg = ToolkitRegistry.getEntry();

		// Triggering on EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
		obReg.setEvent(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM);

		// Triggering on EVENT_MENU_SELECTION
		//item =
		obReg.initMenuEntry(MenuEntry, BEGINNING_OF_STRING, (short)MenuEntry.length, NEXT_ACTION_INDICATOR, false, (byte)0, (short)0);
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength)
    {
        // Create a new applet instance
        FWK_ERP_EMCN_3 thisApplet = new FWK_ERP_EMCN_3();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();

    }


    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event)
    {
		// Result of each test
		boolean bRes = false;

		// Get the system instance of the EnvelopeHandler class
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();

		switch ( event )
			{
				case EVENT_MENU_SELECTION :
				// --------------------------------------------
				// The applet prepares and send a Display Text Proactive command with the string "APPLET"
				try {
					// Get the system instance of the ProactiveHandler class
					ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
					bRes = false;
					proHdlr.initDisplayText(WAIT_FOR_USER_TO_CLEAR_MESSAGE, DCS_8_BIT_DATA, BUFFER, BEGINNING_OF_STRING, (short)BUFFER.length) ;
					proHdlr.send();
					bRes = true;
				}
				catch (Exception e)    {
				    bRes = false;
				}
				reportTestOutcome((byte)1, bRes);
				break;

				case EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM :
				// --------------------------------------------
				// The applet changes any incoming TP_Destination_Address and any RP_Destination_Address
				// of the Service Center into + 11 22 33 44

					// Get the system instance of the EnvelopeResponseHandler class
					EnvelopeResponseHandler envRespHandler = EnvelopeResponseHandler.getTheHandler();

					envRespHandler.appendTLV((byte)(TAG_ADDRESS | TAG_SET_CR), DATA2POST, (short)0x00, (short)DATA2POST.length);
					envRespHandler.appendTLV((byte)(TAG_ADDRESS | TAG_SET_CR), DATA2POST, (short)0x00, (short)DATA2POST.length);
                    envRespHandler.postAsBERTLV(SW1_RP_ACK, (byte)0x02);

				break;


			}

	}
}
