//-----------------------------------------------------------------------------
// Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_exh_imtg;


//-----------------------------------------------------------------------------
// Imports
//-----------------------------------------------------------------------------

import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.* ;

/**
 * Test Area : sim.framework...
 *
 * @version 0.0.2 - 14/01/02
 *
 */


public class FWK_EXH_IMTG_2 extends TestToolkitApplet {


    /**
     * The Constructor registers the application for the Event.
     */

    private FWK_EXH_IMTG_2() {

        //register to EVENT_STATUS_COMMAND
        obReg.requestPollInterval((short)POLL_SYSTEM_DURATION);
        //register to EVENT_PROFILE_DOWNLOAD
        obReg.setEvent(EVENT_PROFILE_DOWNLOAD);
        //register to EVENT_UNRECOGNIZED_ENVELOPE
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
        //register to EVENT_EVENT_DOWNLOAD_MT_CALL
        obReg.setEvent(EVENT_EVENT_DOWNLOAD_MT_CALL);
        //register to EVENT_UNFORMATTED_SMS_PP_ENV
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
        //register to EVENT_UNFORMATTED_SMS_PP_UPD
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);
        //register to EVENT_UNFORMATTED_SMS_CB
        obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
    }


    /**
     * This method will be used to install the Applet.
     */

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        FWK_EXH_IMTG_2  thisApplet = new FWK_EXH_IMTG_2();

        // Register the applet with the JCRE.
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
    }


    /**
     * This method will be used to trigger the tests.
     * The application will be triggered by an Formatted SMS PP download event.
     * @param event
     */

    public void processToolkit (byte event) throws ToolkitException {
        byte testCaseNb = (byte) 0x00;
        boolean bRes = false;

        if (event == EVENT_STATUS_COMMAND) {

            /*------------------------------------------------------------------
             * TC 01: EVENT_STATUS_COMMAND
             *----------------------------------------------------------------*/
            testCaseNb=(byte)0x01;
            bRes = true;
            reportTestOutcome(testCaseNb, bRes);
        }

        if (event == EVENT_PROFILE_DOWNLOAD) {

            /*------------------------------------------------------------------
             * TC 02: EVENT_PROFILE_DOWNLOAD
             *----------------------------------------------------------------*/
            testCaseNb=(byte)0x02;
            bRes = true;
            reportTestOutcome(testCaseNb, bRes);
        }

        if (event == EVENT_UNRECOGNIZED_ENVELOPE) {

            /*------------------------------------------------------------------
             * TC 03: EVENT_UNRECOGNIZED_ENVELOPE
             *----------------------------------------------------------------*/
            testCaseNb=(byte)0x03;
            bRes = true;
            reportTestOutcome(testCaseNb, bRes);
        }

        if (event == EVENT_EVENT_DOWNLOAD_MT_CALL) {

            /*------------------------------------------------------------------
             * TC 04: EVENT_EVENT_DOWNLOAD_MT_CALL
             *----------------------------------------------------------------*/
            testCaseNb=(byte)0x04;
            bRes = true;
            reportTestOutcome(testCaseNb, bRes);
        }

        if (event == EVENT_UNFORMATTED_SMS_PP_ENV) {

            /*------------------------------------------------------------------
             * TC 05: EVENT_UNFORMATTED_SMS_PP_ENV
             *----------------------------------------------------------------*/
            testCaseNb=(byte)0x05;
            bRes = true;
            reportTestOutcome(testCaseNb, bRes);
        }

        if (event == EVENT_UNFORMATTED_SMS_PP_UPD) {

            /*------------------------------------------------------------------
             * TC 06: EVENT_UNFORMATTED_SMS_PP_UPD
             *----------------------------------------------------------------*/
            testCaseNb=(byte)0x06;
            bRes = true;
            reportTestOutcome(testCaseNb, bRes);
        }

        if (event == EVENT_UNFORMATTED_SMS_CB) {

            /*------------------------------------------------------------------
             * TC 07: EVENT_UNFORMATTED_SMS_CB
             *----------------------------------------------------------------*/
            testCaseNb=(byte)0x07;
            bRes = true;
            reportTestOutcome(testCaseNb, bRes);
        }

    }
}
