//-----------------------------------------------------------------------------
//    FWK_FWS_INDA_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_fws_inda;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;

/**
 * Test Area : sim.toolkit.framework Framework security
 *
 * Applet is triggered on EVENT_FORMATTED_SMS_PP_ENV
 *
 * @author 3GPP T3 SWG API
 *
 */
public class FWK_FWS_INDA_2 extends TestToolkitApplet
{
	
	byte testCaseNb = (byte) 0x01;
	byte[] buffer = new byte[25];

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;

    /**
     * Constructor of the applet
     */
    public FWK_FWS_INDA_2() {
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength)
    {
        // Create a new applet instance
        FWK_FWS_INDA_2 thisApplet = new FWK_FWS_INDA_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();

    }


    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event)
    {
		// Result of each test
		boolean bRes = false;

		// Get the system instance of the EnvelopeHandler class
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();

		short length = 0;
		short offset = 0;
		byte data = 0;

		switch ( testCaseNb ){
		
			case 1:
			
				// --------------------------------------------
				// Test Case 2.3: data ciphered; integrity checked via cryptographic checksum
				//
				// In this test case it is checked that the checksum is verified and the data are deciphered
				// before being passed to the applet
			
				try {
					bRes = false;
					offset = envHdlr.getSecuredDataOffset();
					length = envHdlr.getSecuredDataLength();
					envHdlr.copyValue(offset, (byte[])buffer, (short)0x00, length);
					data = buffer [0];
				    if ((data == (byte)5) && (length == (byte)1)) {
					    bRes = true;
					}
				}
				catch (Exception e)    {
				    bRes = false;
				}
				reportTestOutcome(testCaseNb, bRes);
				testCaseNb=(byte)0x02;
				
				break;
				
			case 2:
			
				// --------------------------------------------
				// Test Case 2.4: data ciphered; integrity checked via cryptographic checksum
				//
				// In this test case it is checked that the checksum is verified and the data are deciphered
				// before being passed to the applet
				try {
					bRes = false;
					offset = envHdlr.getSecuredDataOffset();
					length = envHdlr.getSecuredDataLength();
					envHdlr.copyValue(offset, (byte[])buffer, (short)0x00, (short)20);
					data = buffer [0];
				    if ((data == (byte)6) && (length == (short)150)) {
					    bRes = true;
					}
				}
				catch (Exception e)    {
				    bRes = false;
				}
				reportTestOutcome(testCaseNb, bRes);
				testCaseNb=(byte)0x03;
				reportTestOutcome(testCaseNb, true);
				
				break;	
				
			default:	
			
				reportTestOutcome((byte)0x03, false);
				break;
		}	
	}
}
