//-----------------------------------------------------------------------------
//    FWK_HIN_PAHD_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_hin_pahd;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Minimum Handler Integrity
 *
 * Applet is triggered on Install (Install, all events
 *
 * @version 0.0.1 - 15/11/01
 *
 */

 public class FWK_HIN_PAHD_1 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;
     private byte[] TEXT={(byte)'T',(byte)'e',(byte)'x',(byte)'t',(byte)'1'};
     private byte[] buffer1;
     private byte[] buffer2;
     private boolean bRes;

    //Constructor of the applet

    public FWK_HIN_PAHD_1(){
        //register to EVENT_UNFORMATTED_SMS_PP_ENV
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
        buffer1=new byte[9];
        buffer2=new byte[9];
    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_HIN_PAHD_1 thisApplet = new FWK_HIN_PAHD_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

        bRes=true;
        testCaseNb =(byte)0x01;
        //get the Proactive Handler
        ProactiveHandler prHdlr =ProactiveHandler.getTheHandler();
        try{
            //the Proactive Handler length must be 0
            if(prHdlr.getLength()!=(byte)0){
                bRes=false;
            }
        }
        catch(Exception e){
            bRes=false;
        }
        reportTestOutcome(testCaseNb,bRes);

        testCaseNb=(byte)0x02;
        try{
            //the handler change after the init method invocation
            bRes=true;
            //build a Proactive Command Display Text
            prHdlr.init(PRO_CMD_DISPLAY_TEXT, (byte)0x80, DEV_ID_DISPLAY);
            //the init command is excuted and the handler lenght must be 9
            if(prHdlr.getLength()!=(byte)9){
                bRes=false;
            }
        }
        catch(Exception e){
            bRes=false;
        }
        reportTestOutcome(testCaseNb,bRes);

        testCaseNb=(byte)0x03;
        try{
            //the handler remain unchange before the execution of the send command
            bRes=true;
            prHdlr.copy(buffer1,(short)0,(short)prHdlr.getLength());
            prHdlr.send();
            prHdlr.copy(buffer2,(short)0,(short)prHdlr.getLength());
            //the nandler length must be 9
            if(prHdlr.getLength()==9){
                if(Util.arrayCompare(buffer1,(short)0,buffer2,(short)0,(short)prHdlr.getLength())!=0){
                    bRes=false;
                }
            }
            else{
                bRes=false;
            }
        }
        catch(Exception e){
            bRes=false;
        }
            reportTestOutcome(testCaseNb,bRes);
    }

    }

