//-----------------------------------------------------------------------------
//    FWK_MHA_ENHD_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_mha_enhd;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Minimum Handler Availability
 *
 * Applet is triggered on Install (Install, all events
 *
 */

 public class FWK_MHA_ENHD_1 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;

     private byte[] menuEntry1={(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'1'};
     private byte[] menuEntry2={(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'2'};
     private byte[] eventList ={EVENT_PROFILE_DOWNLOAD,EVENT_UNFORMATTED_SMS_PP_ENV,EVENT_FORMATTED_SMS_CB,EVENT_UNFORMATTED_SMS_CB,
                                EVENT_CALL_CONTROL_BY_SIM,EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,EVENT_EVENT_DOWNLOAD_MT_CALL,
                                EVENT_EVENT_DOWNLOAD_CALL_CONNECTED,EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED,EVENT_EVENT_DOWNLOAD_LOCATION_STATUS,
                                EVENT_EVENT_DOWNLOAD_USER_ACTIVITY,EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE,EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS,
                                EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION,EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION,EVENT_UNRECOGNIZED_ENVELOPE,
                                EVENT_FORMATTED_SMS_PP_UPD, EVENT_UNFORMATTED_SMS_PP_UPD, EVENT_FIRST_COMMAND_AFTER_SELECT,
                                EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS, EVENT_EVENT_DOWNLOAD_DATA_AVAILABLE};
     private boolean bRes;
     
     private byte a;
    


    //Constructor of the applet

    public FWK_MHA_ENHD_1(){
        //register to EVENT_MENU_SELECTION
        obReg.initMenuEntry(menuEntry1,(short)0,(short)menuEntry1.length,(byte)0,false,(byte)0,(short)0);
        //register to EVENT_MENU_SELECTION_HELP_REQUEST
        obReg.initMenuEntry(menuEntry2,(short)0,(short)menuEntry2.length,(byte)0,true,(byte)0,(short)0);
        //register to EVENT_TIMER_EXPIRATION
        for(a=0; a<(byte)8; a++){
       	   	obReg.allocateTimer();
       	}
       	for(a=2; a<(byte)9; a++){
       		obReg.releaseTimer((byte)a);       	   		
       	}        
        //register to all event download
        obReg.setEventList(eventList,(short)0,(short)eventList.length);
        //register to EVENT_STATUS_COMMAND
        obReg.requestPollInterval((short)POLL_SYSTEM_DURATION);
    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_MHA_ENHD_1 thisApplet = new FWK_MHA_ENHD_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

       final byte[] CSDBearerDesc = {(byte)0x01, (byte)0x00, (byte)0x00, (byte)0x00};
       final byte[] address = {(byte)0x91, (byte)0x11, (byte)0x22, (byte)0x33, (byte)0x44} ;
       
       // Get the system instance of handlers
       EnvelopeHandler envHdlr = null;
       ProactiveHandler proHdlr = null;
 
       bRes=false;

        switch(event){
            
            //event EVENT_STATUS_COMMAND
            case EVENT_STATUS_COMMAND:
            // event EVENT_FIRST_COMMAND_AFTER_SELECT
            case EVENT_FIRST_COMMAND_AFTER_SELECT:
            //event EVENT_PROFIEL_DOWNLOAD
            case EVENT_PROFILE_DOWNLOAD:
            //for this events the handler is not available
                testCaseNb++;
                try{
                    //get the Envelope Handler
                     EnvelopeHandler.getTheHandler();
                     bRes=false;
                }
                catch(ToolkitException e)
                {
                    //Envelope Handler is not available
                    if(e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE){
                        bRes=true;
                    }
                }

                if(event==EVENT_PROFILE_DOWNLOAD){
                    //deregister to EVENT_PROFILE_DOWNLOAD
                    obReg.clearEvent(event);
                }

                if(event==EVENT_FIRST_COMMAND_AFTER_SELECT){
                    //deregister to EVENT_FIRST_COMMAND_AFTER_SELECT
                    obReg.clearEvent(event);
                }

                if(event==EVENT_STATUS_COMMAND){
                    //Send a CSD OPEN CHANNEL command
                    // ------------------------------
                    proHdlr = ProactiveHandler.getTheHandler();
                    proHdlr.init(PRO_CMD_OPEN_CHANNEL, (byte)0x01, DEV_ID_ME);
                    proHdlr.appendTLV(TAG_ADDRESS, address, (short)0x00, (short)address.length);
                    proHdlr.appendTLV(TAG_BEARER_DESCRIPTION, CSDBearerDesc, (short)0x00, (short)CSDBearerDesc.length);
                    proHdlr.appendTLV(TAG_BUFFER_SIZE, (byte)0x00, (byte)0x80);
                    try {
                       proHdlr.send();
                    }
                    catch (Exception e){ 
                        // testcase on BIP command will fail   
                        reportTestFailure((byte)22);
                        reportTestFailure((byte)23);
                        testCaseNb = (byte)23;
                    }
                }

                reportTestOutcome(testCaseNb,bRes);
            break;
            
            //rest of the events
            default:
                testCaseNb++;
                bRes=false;
                try{
                     //get the Envelop Handler
                     EnvelopeHandler.getTheHandler();
                     bRes=true;
                }
                catch(Exception e){
                    bRes=false;
                }

                reportTestOutcome(testCaseNb,bRes);
        }

    }

 }