//-----------------------------------------------------------------------------
//    FWK_MHA_ERHD_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_mha_erhd;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Minimum Handler Availability
 *
 * Applet is triggered on Install (Install, all events
 *
 */

public class FWK_MHA_ERHD_1 extends TestToolkitApplet {
    
    private byte testCaseNb = (byte) 0x00;
    private byte triggerNb=(byte)0x01;

    private byte[] TEXT= {(byte)'T',(byte)'e',(byte)'x',(byte)'t',(byte)'1'};
    private byte[] MenuEntry1 = {(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'1'};
    private byte[] MenuEntry2 = {(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'2'};
    //List of all events to registered
    private byte[] eventList ={ EVENT_PROFILE_DOWNLOAD, EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_FORMATTED_SMS_CB, EVENT_UNFORMATTED_SMS_CB,
                                EVENT_CALL_CONTROL_BY_SIM, EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM, EVENT_EVENT_DOWNLOAD_MT_CALL,
                                EVENT_EVENT_DOWNLOAD_CALL_CONNECTED, EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED, EVENT_EVENT_DOWNLOAD_LOCATION_STATUS,
                                EVENT_EVENT_DOWNLOAD_USER_ACTIVITY, EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE, EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS,
                                EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION, EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION, EVENT_UNRECOGNIZED_ENVELOPE,
                                EVENT_EVENT_DOWNLOAD_DATA_AVAILABLE, EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS, EVENT_FIRST_COMMAND_AFTER_SELECT, EVENT_FORMATTED_SMS_PP_UPD,
                                EVENT_UNFORMATTED_SMS_PP_UPD};
    private byte[] sendData;
    private boolean bRes;
    public final static byte QUALIFIER_1 = (byte)0x01;
    public static byte[] ADDRESS_VALUE = {(byte)0x81, (byte)0x55, (byte)0x66, (byte)0x77, (byte)0x88};
    public static byte[] BEARER_VALUE = {(byte)0x03, (byte)0x00};
    public static byte[] BUFFER_SIZE_VALUE = {(byte)0x00, (byte)0x01};

     
    private byte a;


    // Constructor of the applet
    public FWK_MHA_ERHD_1() {
        // register to EVENT_MENU_SELECTION
        obReg.initMenuEntry(MenuEntry1,(short)0,(short)MenuEntry1.length,(byte)0,false,(byte)0,(short)0);
        // register to EVENT_MENU_SELECTION_HELP_REQUEST
        obReg.initMenuEntry(MenuEntry2,(short)0,(short)MenuEntry2.length,(byte)0,true,(byte)0,(short)0);
        // register to EVENT_TIMER_EXPIRATION
        for(a=0; a<(byte)8; a++) {
       	   	obReg.allocateTimer();
       	}
       	for(a=2; a<(byte)9; a++) {
       		obReg.releaseTimer((byte)a);       	   		
       	}
        // register to EVENT_STATUS_COMMAND
        obReg.requestPollInterval((short)POLL_SYSTEM_DURATION);
        // register to the rest of the events including the event download events
        obReg.setEventList(eventList,(short)0,(short)eventList.length);
        // initialise the buffer to prepare the posted data
        sendData=new byte[(byte)0x10];
        Util.arrayFillNonAtomic(sendData,(short)0x00,(short)0x10,(byte)0x55);
    }


    // Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength) {

        // Create a new applet instance
        FWK_MHA_ERHD_1 thisApplet = new FWK_MHA_ERHD_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();
    }

    //---------------------------------------------------------------------------------------
    // This method call all methods of EnvelopeResponseHandler including the inherited methods
    //---------------------------------------------------------------------------------------
    boolean testAllMethodsOfEnvRespHandler(EnvelopeResponseHandler envRespHdlr) {
        
        bRes=true;
        byte testSubCaseNb= (byte)0x01;

        while((bRes) && (testSubCaseNb<0x16)) {

            try {
                switch(testSubCaseNb) {
                    case (byte)0x01:
                        EnvelopeResponseHandler envRespHdlrF = EnvelopeResponseHandler.getTheHandler();
                        bRes=false;
                        break;
                    case (byte)0x02:
                        envRespHdlr.post(SW1_RP_ACK);
                        bRes=false;
                        break;
                    case (byte)0x03:
                        envRespHdlr.postAsBERTLV((byte)0x33,SW1_RP_ACK);
                        bRes=false;
                        break;
                    case (byte)0x04:
                        envRespHdlr.appendArray(sendData,(short)0x00,(short)sendData.length);
                        bRes=false;
                        break;
                    case (byte)0x05:
                        envRespHdlr.appendTLV((byte)0x66,(byte)0x77);
                        bRes=false;
                        break;
                    case (byte)0x06:
                        envRespHdlr.appendTLV((byte)0x66,sendData,(short)0x00,(short)sendData.length);
                        bRes=false;
                        break;
                    case (byte)0x07:
                        envRespHdlr.appendTLV((byte)0x66,(byte)0x77,(byte)0x22);
                        bRes=false;
                        break;
                    case (byte)0x08:
                        envRespHdlr.appendTLV((byte)0x66,(byte)0x77,sendData,(short)0x00,(short)sendData.length);
                        bRes=false;
                        break;
                    case (byte)0x09:
                        envRespHdlr.clear();
                        bRes=false;
                        break;
                    case (byte)0x0A:
                        envRespHdlr.compareValue((short)0x01,sendData,(short)0x00,(short)sendData.length);
                        bRes=false;
                        break;
                    case (byte)0x0B:
                        envRespHdlr.copy(sendData,(short)0x00,(short)0x7F);
                        bRes=false;
                        break;
                    case (byte)0x0C:
                        envRespHdlr.copyValue((short)0x00,sendData,(short)0x00,(short)0x7F);
                        bRes=false;
                        break;
                    case (byte)0x0D:
                        envRespHdlr.findAndCompareValue((byte)0x44,sendData,(short)0x00);
                        bRes=false;
                        break;
                    case (byte)0x0E:
                        envRespHdlr.findAndCompareValue((byte)0x44,(byte)0x01,(short)0x00,sendData,(short)0x00,(short)0x7F);
                        bRes=false;
                        break;
                    case (byte)0x0F:
                        envRespHdlr.findAndCopyValue((byte)0x44,sendData,(short)0x00);
                        bRes=false;
                        break;
                    case (byte)0x10:
                        envRespHdlr.findAndCopyValue((byte)0x44,(byte)0x01,(short)0x00,sendData,(short)0x00,(short)0x7F);
                        bRes=false;
                        break;
                    case (byte)0x11:
                        envRespHdlr.findTLV((byte)0x44,(byte)0x01);
                        bRes=false;
                        break;
                    case (byte)0x12:
                        envRespHdlr.getLength();
                        bRes=false;
                        break;
                    case (byte)0x13:
                        envRespHdlr.getValueByte((short)0x00);
                        bRes=false;
                        break;
                    case (byte)0x14:
                        envRespHdlr.getValueLength();
                        bRes=false;
                        break;
                    case (byte)0x15:
                        envRespHdlr.getCapacity();
                        bRes=false;
                        break;
                }
            }
            catch(ToolkitException e) {
                if(e.getReason()!=ToolkitException.HANDLER_NOT_AVAILABLE) {
                    bRes=false;
                }
            }
            catch(Exception e) {
                bRes=false;
            }
            testSubCaseNb++;
        }
        return (bRes);
    }


    // Method called by the SIM Toolkit Framework
    public void processToolkit(byte event) {

        bRes=false;

        switch(event) {

        //------------------------------------------------------------------Test case 1 to 21---------------------------------------------------------
        // For these events the EnvelopeResponseHandler is not available
        case EVENT_PROFILE_DOWNLOAD:
        case EVENT_FORMATTED_SMS_CB:
        case EVENT_UNFORMATTED_SMS_CB:
        case EVENT_MENU_SELECTION:
        case EVENT_MENU_SELECTION_HELP_REQUEST:
        case EVENT_TIMER_EXPIRATION:
        case EVENT_EVENT_DOWNLOAD_MT_CALL:
        case EVENT_EVENT_DOWNLOAD_CALL_CONNECTED:
        case EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED:
        case EVENT_EVENT_DOWNLOAD_LOCATION_STATUS:
        case EVENT_EVENT_DOWNLOAD_USER_ACTIVITY:
        case EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE:
        case EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS:
        case EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION:
        case EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION:
        case EVENT_STATUS_COMMAND:
        case EVENT_EVENT_DOWNLOAD_DATA_AVAILABLE:
        case EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS:
        case EVENT_FIRST_COMMAND_AFTER_SELECT:
        case EVENT_FORMATTED_SMS_PP_UPD:
        case EVENT_UNFORMATTED_SMS_PP_UPD:
            testCaseNb++;
            try {
                EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();
                bRes=false;
            }
            catch(ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE);
                if ((event==EVENT_PROFILE_DOWNLOAD) || (event==EVENT_FIRST_COMMAND_AFTER_SELECT)) {
                    obReg.clearEvent(event);
                }
            }
            catch(Exception e) {
                bRes=false;
            }
            reportTestOutcome(testCaseNb,bRes);

            // Open Channel for EVENT_EVENT_DOWNLOAD_DATA_AVAILABLE and EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS
            if (event == EVENT_STATUS_COMMAND) {
                // get the Proactive Handler
                ProactiveHandler proHdlr = ProactiveHandler.getTheHandler();
                bRes=true;
                // Open Channel proactive command for test cases 18 and 19
                proHdlr.init(PRO_CMD_OPEN_CHANNEL, QUALIFIER_1, DEV_ID_ME);
                proHdlr.appendTLV(TAG_ADDRESS, ADDRESS_VALUE, (short)0, (short)5);
                proHdlr.appendTLV(TAG_BEARER_DESCRIPTION, BEARER_VALUE, (short)0, (short)2);
                proHdlr.appendTLV(TAG_BUFFER_SIZE, BUFFER_SIZE_VALUE, (short)0, (short)2);
                proHdlr.send();
            }
            break;

        default:
        //-------------------------------------------------------------------Test cases 17 to 22---------------------------------------------------------
        // These tests cases are only for EVENT_FORMATTED_SMS_PP_ENV, EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_UNRECOGNIZED_ENVELOPE, EVENT_CALL_CONTROL_BY_SIM AND
        // EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
        // The value of testCaseNb must be 21
        //-----------------------------------------------------------------------------------------------------------------------------------------------
            bRes=true;
            switch(testCaseNb) {


            // Test cases 22,23,24,25
            // In the first trigger the application builds the response and calls the 
            // post() method in the case of EVENT_FORMATTED_SMS_PP_ENV and EVENT_UNFORMATTED_SMS_PP_ENV
            // and posAsBERTLV() method in other cases
            // All methods of EnvelopeResponseHandler are called and the EnvelopeResponse handler is not
            // available
            //default:
            case (byte)21:
            case (byte)22:
            case (byte)23:
            case (byte)24:
            case (byte)25:
                if(triggerNb==(byte)0x01) {

                    try {
                        triggerNb=(byte)0x02;
                        EnvelopeResponseHandler envRespHdlr =EnvelopeResponseHandler.getTheHandler();
                        envRespHdlr.appendArray(sendData,(short)0x00,(short)0x10);
                        if(event==EVENT_FORMATTED_SMS_PP_ENV || event==EVENT_UNFORMATTED_SMS_PP_ENV) {
                            envRespHdlr.post(SW1_RP_ACK);
                        } else {
                            envRespHdlr.postAsBERTLV(SW1_RP_ACK,(byte)0x44);
                        }
                        bRes=testAllMethodsOfEnvRespHandler(envRespHdlr);
                    }
                    catch(Exception e) {
                          bRes=false;
                    }
                // In the second trigger the applet builds a Display Text command 
                // All methods of EnvelopeResponseHandler are called and the EnvelopeResponse handler is not
                // available                        
                } else {                          
                    if(bRes) {
                        triggerNb=(byte)0x01;
                        try {                                   	
                            ProactiveHandler prHdlr=ProactiveHandler.getTheHandler();
                            EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();
                            prHdlr.initDisplayText((byte)0x80,DCS_8_BIT_DATA,TEXT,(short)0,(short)TEXT.length);
                            prHdlr.send();
                            bRes=testAllMethodsOfEnvRespHandler(envRespHdlr);
                        }
                        catch(Exception e) {
                            bRes=false;
                        }
                    }
                    testCaseNb++;
                    reportTestOutcome(testCaseNb,bRes);
                }
                break;
            // The envelope response is sent when a proactive session is ongoing.
		    // The application builds a Display Text Command and before the send() method a 
		    // EVENT_CALL_CONTROL_BY_SIM is sent and the application builds the EnvelopeResponseHandler
		    // information and calls the postAsBERTLV() method.
		    // After the Display Text command is sent.	
            case (byte)26:
                if(triggerNb==1) {
                    try {                            	
                        triggerNb=(byte)0x02;
                        ProactiveHandler prHdlr=ProactiveHandler.getTheHandler();
                        prHdlr.initDisplayText((byte)0x80,DCS_8_BIT_DATA,TEXT,(short)0,(short)TEXT.length);
                        prHdlr.send();
                        testCaseNb++;
                        reportTestOutcome(testCaseNb,bRes);

                    }
                    catch(Exception e) {
                        bRes=false;
                    }
                } else {
                    if(bRes) {
                        try {
                            EnvelopeResponseHandler envRespHdlr =EnvelopeResponseHandler.getTheHandler();
                            envRespHdlr.appendArray(sendData,(short)0x00,(short)0x10);
                            envRespHdlr.postAsBERTLV(SW1_RP_ACK,(byte)0x44);
                        }
                        catch(Exception e) {
                            bRes=false;
                        }
                    }
                    testCaseNb++;
                    reportTestOutcome(testCaseNb,bRes);
                }
                
                break;
            // multi-triggering
            case (byte)27: 
            case (byte)28:
                try {                            	
                    EnvelopeResponseHandler envRespHdlr =EnvelopeResponseHandler.getTheHandler();
                }
                catch (ToolkitException e) {
                    bRes = (e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE);
                }
                catch(Exception e) {
                    bRes=false;
                }
                testCaseNb++;
                reportTestOutcome(testCaseNb,bRes);
                break;

            }
        }
    }
}

