//-----------------------------------------------------------------------------
//    FWK_MHA_ERHD_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_mha_erhd;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Minimum Handler Availability
 *
 * Applet is triggered on Install Install, all events
 *
 */

 public class FWK_MHA_ERHD_2 extends TestToolkitApplet {

     private byte testCaseNb = (byte) 0x00;
     private boolean bRes;



    // Constructor of the applet

    public FWK_MHA_ERHD_2() {

        // register to EVENT_UNFORMATTED_SMS_PP_ENV
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
        // register to EVENT_UNRECOGNIZED_ENVELOPE
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);

    }


    // Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength) {

        // Create a new applet instance
        FWK_MHA_ERHD_2 thisApplet = new FWK_MHA_ERHD_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();
    }


    // Method called by the SIM Toolkit Framework
    public void processToolkit(byte event) {
            
        byte[]  sendData=new byte[(byte)0x10];
        Util.arrayFillNonAtomic(sendData,(short)0x00,(short)0x10,(byte)0x55);

        bRes=false;
        if ((event == EVENT_UNFORMATTED_SMS_PP_ENV) || (event == EVENT_UNRECOGNIZED_ENVELOPE)) {
            switch(testCaseNb) {
            case (byte)0x00:
            case (byte)0x01:
            case (byte)0x02:
            case (byte)0x03:
                try {
                    EnvelopeResponseHandler envRespHdlr=EnvelopeResponseHandler.getTheHandler();
                    bRes=false;
                }
                catch(ToolkitException e) {
                    bRes = (e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE);
                }
                catch(Exception e) {
                    bRes=false;
                }
                testCaseNb++;
                reportTestOutcome(testCaseNb,bRes);
                break;


            case (byte)0x04:
            case (byte)0x05:
                testCaseNb++;
                try {
                    EnvelopeResponseHandler envRespHdlr =EnvelopeResponseHandler.getTheHandler();
                    envRespHdlr.appendArray(sendData,(short)0x00,(short)0x10);
                    if(event==EVENT_UNFORMATTED_SMS_PP_ENV) {
                        envRespHdlr.post(SW1_RP_ACK);
                    } else {
                        envRespHdlr.postAsBERTLV(SW1_RP_ACK,(byte)0x44);
                    }
                    bRes=true;
                }
                catch(Exception e) {
                    bRes=false;
                }
                reportTestOutcome(testCaseNb,bRes);
                break;
            }
        }
    }

 }