//-----------------------------------------------------------------------------
//    FWK_MHA_PAHD_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_mha_pahd;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Minimum Handler Availability
 *
 * Applet is triggered on Install (Install), all events
 *
 */

 public class FWK_MHA_PAHD_2 extends TestToolkitApplet {

     private byte testCaseNb = (byte) 0x00;
     private byte[] MenuEntry3 = {(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'3'};
     private byte[] MenuEntry4 = {(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'4'};
     private byte[] eventList ={EVENT_PROFILE_DOWNLOAD,EVENT_UNFORMATTED_SMS_PP_ENV,EVENT_UNFORMATTED_SMS_CB,
                                EVENT_EVENT_DOWNLOAD_MT_CALL,EVENT_EVENT_DOWNLOAD_CALL_CONNECTED,EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED,
                                EVENT_EVENT_DOWNLOAD_LOCATION_STATUS,EVENT_EVENT_DOWNLOAD_USER_ACTIVITY,EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE,
                                EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS,EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION,
                                EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION,EVENT_UNRECOGNIZED_ENVELOPE,EVENT_UNFORMATTED_SMS_PP_UPD,
                                EVENT_FIRST_COMMAND_AFTER_SELECT};

     private boolean bRes;
     
    // Constructor of the applet
    public FWK_MHA_PAHD_2() {

        // register to EVENT_STATUS_COMMAND
        obReg.requestPollInterval((short)POLL_SYSTEM_DURATION);
        // register to the rest of the events included the event download events
        obReg.setEventList(eventList,(short)0,(short)eventList.length);
    }


    // Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength) {

        // Create a new applet instance
        FWK_MHA_PAHD_2 thisApplet = new FWK_MHA_PAHD_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    // Method called by the SIM Toolkit Framework

    public void processToolkit(byte event) {

        // for each event the handler must be available
        testCaseNb++;
        bRes = false;

        switch(event){
        // event EVENT_FIRST_COMMAND_AFTER_SELECT
        case EVENT_FIRST_COMMAND_AFTER_SELECT:
            try {
                // get the Proactive Handler
                ProactiveHandler proHdlr=ProactiveHandler.getTheHandler();
                bRes=false;
            }
            catch(ToolkitException e){
                if (e.getReason() == ToolkitException.HANDLER_NOT_AVAILABLE) {
                    bRes = true;
                } else {
                    bRes = false;
                }
            }
            // deregister to EVENT_FIRST_COMMAND_AFTER_SELECT
            obReg.clearEvent(event);
            reportTestOutcome(testCaseNb,bRes);
            break;

        // event EVENT_PROFILE_DOWNLOAD
        case EVENT_PROFILE_DOWNLOAD:
            try {
                // get the Proactive Handler
                ProactiveHandler proHdlr=ProactiveHandler.getTheHandler();
                // deregister to EVENT_PROFILE_DOWNLOAD
                obReg.clearEvent(event);
                bRes = true;
            }
            catch(Exception e){
                bRes = false;
            }
            reportTestOutcome(testCaseNb,bRes);
            break;

        // rest of the events registered
        default:

            try {
                // get the Proactive Handler
                ProactiveHandler proHdlr = ProactiveHandler.getTheHandler();
                bRes = true;
            }
            catch(Exception e){
                bRes = false;
            }
            reportTestOutcome(testCaseNb,bRes);
        }
    }

 }