//-----------------------------------------------------------------------------
//    API_2_ENH_GCAP_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_gcap;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeHandler.getCapacity()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_ENH_GCAP_1  extends TestToolkitApplet
{

    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public API_2_ENH_GCAP_1 () 
    {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_GCAP_1  thisApplet = new API_2_ENH_GCAP_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes;
        
        // results of methods
        short sLength = 0;
        short sCapacity = 0;
                
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
        
	    // Get length of the BER TLV
		bRes = false;
		testCaseNb++;
	    try {
	        sLength = envHdlr.getLength();
	        bRes = true;
	    }
		catch (Exception e)  {    
			bRes = false;
    	}
    	
    	// get capacity of the handler
	    try {
	        sCapacity = envHdlr.getCapacity();
	        bRes &= true;
	    }
		catch (Exception e)  {    
			bRes &= false;
    	}
    	
        // Capacity must be greater than length of BER TLV
        if (sCapacity < sLength)
        {
			bRes &= false;
        }
        else
        {
	        bRes &= true;
        }
		reportTestOutcome(testCaseNb, bRes) ;
	}
}
