//-----------------------------------------------------------------------------
//    API_2_ENH_GUDL_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_gudl;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeHandler.getUserDataLength()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_ENH_GUDL_1  extends TestToolkitApplet
{

    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public API_2_ENH_GUDL_1 () 
    {
		// Set Formatted SMS PP UPD as an activation event for the applet
        obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
		
		// Set Unformatted SMS PP ENV as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);

		// Set Unformatted SMS PP UPD as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);

		// Set Unrecognized envelope as an activation event for the applet
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_GUDL_1  thisApplet = new API_2_ENH_GUDL_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    switch ( testCaseNb ) 
		{
		    //=================================================================
		    //=========        FORMATTED SMS PP ENV triggering        =========
		    //=================================================================
			case (byte) 0 :
				// --------------------------------------------
				// Test Case 1 : getUserDataLength with various length of TP-OA:2
				testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x003D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 1 :
				// --------------------------------------------
				// Test Case 2 : getUserDataLength with various length of TP-OA:12
				testCaseNb = (byte) 2 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x003D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 2 :
				// --------------------------------------------
				// Test Case 3 : getUserDataLength with various length of RC/CC/DS:0 
				testCaseNb = (byte) 3 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0023)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 3 :
				// --------------------------------------------
				// Test Case 4 : getUserDataLength with various length of RC/CC/DS:8
				testCaseNb = (byte) 4 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x002B)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 4 :
				// --------------------------------------------
				// Test Case 5 : getUserDataLength with various PCNTR value : PCNTR = 0
				testCaseNb = (byte) 5 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0023)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 5 :
				// --------------------------------------------
				// Test Case 6 : getUserDataLength with various PCNTR value : PCNTR = 7
				testCaseNb = (byte) 6 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x001F)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 6 :
				// --------------------------------------------
				// Test Case 7 : getUserDataLength with no Secured Data
				testCaseNb = (byte) 7 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0013)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 7 :
				// --------------------------------------------
				// Test Case 8 : getUserDataLength with User Data Length = 0x7F
				testCaseNb = (byte) 8 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x007F)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 8 :
				// --------------------------------------------
				// Test Case 9 : getUserDataLength with User Data Length = 0x80
				testCaseNb = (byte) 9 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0080)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 9 :
				// --------------------------------------------
				// Test Case 10 : getUserDataLength with maximum User Data Length = 0x8C
				//                  for a single SMS
				testCaseNb = (byte) 10 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x008C)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 10 :
				// --------------------------------------------
				// Test Case 11 : getUserDataLength when the SMS PP contains 2 TLV
				testCaseNb = (byte) 11 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0018)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 11 :
				// --------------------------------------------
				// Test Case 12 : findTLV device Identities (Formatted SMS PP envelope)
				testCaseNb = (byte) 12 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getUserDataLength() == 0x0018)&&
						(envHdlr.getValueByte((short)0)==0x40))
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 12 :
				// --------------------------------------------
				// Test Case 13 : getUserDataLength with User Data Length = 0x00FF
				//                  using concatenated SMS with 2 envelopes
				testCaseNb = (byte) 13 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x00FF)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 13 :
				// --------------------------------------------
				// Test Case 14 : getUserDataLength with User Data Length = 0x0100
				//                  using concatenated SMS with 2 envelopes
				testCaseNb = (byte) 14 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0100)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 14 :
				// --------------------------------------------
				// Test Case 15 : getUserDataLength with maximun User Data Length = 0x010D
				//                  using concatenated SMS with 2 envelopes
				testCaseNb = (byte) 15 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x010D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			

		    //=================================================================
		    //=========        FORMATTED SMS PP UPD triggering        =========
		    //=================================================================
			case (byte) 15 :
				// --------------------------------------------
				// Test Case 16 : getUserDataLength with various length of TP-OA:2
				testCaseNb = (byte) 16 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x003D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 16 :
				// --------------------------------------------
				// Test Case 17 : getUserDataLength with various length of TP-OA:12
				testCaseNb = (byte) 17 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x003D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 17 :
				// --------------------------------------------
				// Test Case 18 : getUserDataLength with various length of RC/CC/DS:0 
				testCaseNb = (byte) 18 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0023)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 18 :
				// --------------------------------------------
				// Test Case 19 : getUserDataLength with various length of RC/CC/DS:8
				testCaseNb = (byte) 19 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x002B)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 19 :
				// --------------------------------------------
				// Test Case 20 : getUserDataLength with various PCNTR value : PCNTR = 0
				testCaseNb = (byte) 20 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0023)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 20 :
				// --------------------------------------------
				// Test Case 21 : getUserDataLength with various PCNTR value : PCNTR = 7
				testCaseNb = (byte) 21 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x001F)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 21 :
				// --------------------------------------------
				// Test Case 22 : getUserDataLength with no Secured Data
				testCaseNb = (byte) 22 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0013)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 22 :
				// --------------------------------------------
				// Test Case 23 : getUserDataLength with User Data Length = 0x7F
				testCaseNb = (byte) 23 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x007F)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 23 :
				// --------------------------------------------
				// Test Case 24 : getUserDataLength with User Data Length = 0x80
				testCaseNb = (byte) 24 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0080)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 24 :
				// --------------------------------------------
				// Test Case 25 : getUserDataLength with maximum User Data Length = 0x8C
				//                  for a single SMS
				testCaseNb = (byte) 25 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x008C)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 25 :
				// --------------------------------------------
				// Test Case 26 : getUserDataLength when the SMS PP contains 2 TLV
				testCaseNb = (byte) 26 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0018)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 26 :
				// --------------------------------------------
				// Test Case 27 : findTLV device Identities (Formatted SMS PP envelope)
				testCaseNb = (byte) 27 ;

				bRes = false ;
				try {
					if(
						(envHdlr.getUserDataLength() == 0x0018)&&
						(envHdlr.getValueByte((short)0)==0x40))
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 27 :
				// --------------------------------------------
				// Test Case 28 : getUserDataLength with User Data Length = 0x00FF
				//                  using concatenated SMS with 2 envelopes
				testCaseNb = (byte) 28 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x00FF)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 28 :
				// --------------------------------------------
				// Test Case 29 : getUserDataLength with User Data Length = 0x0100
				//                  using concatenated SMS with 2 envelopes
				testCaseNb = (byte) 29 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0100)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 29 :
				// --------------------------------------------
				// Test Case 30 : getUserDataLength with maximun User Data Length = 0x010D
				//                  using concatenated SMS with 2 envelopes
				testCaseNb = (byte) 30 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x010D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
		    //=================================================================
		    //=========       UNFORMATTED SMS PP ENV triggering       =========
		    //=================================================================
			case (byte) 30 :
				// --------------------------------------------
				// Test Case 31 : getUserDataLength with various length of TP-OA:2
				testCaseNb = (byte) 31 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x003D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 31 :
				// --------------------------------------------
				// Test Case 32 : getUserDataLength with various length of TP-OA:12
				testCaseNb = (byte) 32 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x003D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 32 :
				// --------------------------------------------
				// Test Case 33 : getUserDataLength with no User Data
				testCaseNb = (byte) 33 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0000)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 33 :
				// --------------------------------------------
				// Test Case 34 : getUserDataLength with User Data Length = 0x7F
				testCaseNb = (byte) 34 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x007F)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 34 :
				// --------------------------------------------
				// Test Case 35 : getUserDataLength with User Data Length = 0x80
				testCaseNb = (byte) 35 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0080)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 35 :
				// --------------------------------------------
				// Test Case 36 : getUserDataLength with maximum User Data Length = 0x8C
				//                  for a single SMS
				testCaseNb = (byte) 36 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x008C)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 36 :
				// --------------------------------------------
				// Test Case 37 : getUserDataLength when the SMS PP contains 2 TLV
				testCaseNb = (byte) 37 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0018)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 37 :
				// --------------------------------------------
				// Test Case 38 : findTLV device Identities (Formatted SMS PP envelope)
				testCaseNb = (byte) 38 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getUserDataLength() == 0x0018)&&
						(envHdlr.getValueByte((short)0)==0x00))
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

		    //=================================================================
		    //=========       UNFORMATTED SMS PP UPD triggering       =========
		    //=================================================================
			case (byte) 38 :
				// --------------------------------------------
				// Test Case 39 : getUserDataLength with various length of TP-OA:2
				testCaseNb = (byte) 39 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x003D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 39 :
				// --------------------------------------------
				// Test Case 40 : getUserDataLength with various length of TP-OA:12
				testCaseNb = (byte) 40 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x003D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 40 :
				// --------------------------------------------
				// Test Case 41 : getUserDataLength with no User Data
				testCaseNb = (byte) 41 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0000)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 41 :
				// --------------------------------------------
				// Test Case 42 : getUserDataLength with User Data Length = 0x7F
				testCaseNb = (byte) 42 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x007F)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 42 :
				// --------------------------------------------
				// Test Case 43 : getUserDataLength with User Data Length = 0x80
				testCaseNb = (byte) 43 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0080)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 43:
				// --------------------------------------------
				// Test Case 44 : getUserDataLength with maximum User Data Length = 0x8C
				//                  for a single SMS
				testCaseNb = (byte) 44 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x008C)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 44 :
				// --------------------------------------------
				// Test Case 45 : getUserDataLength when the SMS PP contains 2 TLV
				testCaseNb = (byte) 45 ;

				bRes = false ;
				try {
					if (envHdlr.getUserDataLength() == 0x0018)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 45 :
				// --------------------------------------------
				// Test Case 46 : findTLV device Identities (Formatted SMS PP envelope)
				testCaseNb = (byte) 46 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getUserDataLength() == 0x0018)&&
						(envHdlr.getValueByte((short)0)==0x00))
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;


		    //=================================================================
		    //=========       UNRECOGNIZED ENVELOPE triggering        =========
		    //=================================================================

			case (byte) 46 :
				// --------------------------------------------
				// Test Case 47 : try to apply the getUserDataLength method on an unrecognized envelope
				testCaseNb = (byte) 47 ;

				bRes = false ;
				try {
					short returnvalue = envHdlr.getUserDataLength();
				}
				catch (ToolkitException e)    {
					if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT) 
						bRes = true ;
					else
						bRes = false ;
				}
				catch (Exception e)    {    
						bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		}
	}
}
