//-----------------------------------------------------------------------------
//    API_2_PAH_GCAP_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_pah_gcap;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.ProactiveHandler.getCapacity()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_PAH_GCAP_1  extends TestToolkitApplet
{

    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
    private byte[] Buffer;

    /**
     * Constructor of the applet
     */
    public API_2_PAH_GCAP_1 () 
    {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_PAH_GCAP_1  thisApplet = new API_2_PAH_GCAP_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes;
        
        // results of methods
        short sLength = 0;
        short sCapacity = 0;

        // Get the system instance of handlers
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler();

        // get capacity of the handler
        testCaseNb = (byte)0x01;
        bRes = false;
        try {
            sCapacity = proHdlr.getCapacity();
            bRes = true;
        }
        catch (Exception e)  {    
            bRes = false;
        }
        reportTestOutcome(testCaseNb, bRes) ;
        
        // Fill the handler with the maximum capacity
        testCaseNb = (byte)0x02;
        bRes = false;
        Buffer = new byte[sCapacity];
        for (short i=0; i<sCapacity; i++)
            Buffer[i] = (byte)0x55;

        try {
            if (sCapacity <= 0x81)
            {
                proHdlr.appendTLV((byte)0xAA, Buffer, (short)0x00, (short)(sCapacity - 2));
            }
            else if ((sCapacity > 0x81) && (sCapacity <= 0x102))
            {
                proHdlr.appendTLV((byte)0xAA, Buffer, (short)0x00, (short)(sCapacity - 3));
            }
            else if (sCapacity > 0x102)
            {
                proHdlr.appendTLV((byte)0xAA, Buffer, (short)0x00, (short)(sCapacity - 4));
            }
            bRes = true;
        }
        catch (Exception e)  {    
            bRes = false;
        }
        reportTestOutcome(testCaseNb, bRes) ;
    
        // clear the handler
        testCaseNb = (byte)0x03;
        bRes = false;
        try {
            proHdlr.clear();
            bRes = true;
        }
        catch (Exception e)  {    
            bRes = false;
        }
        reportTestOutcome(testCaseNb, bRes) ;
    
        // Fill the handler with the maximum capacity + 1
        testCaseNb = (byte)0x04;
        bRes = false;
        try {
            if (sCapacity <= 0x81)
            {
                proHdlr.appendTLV((byte)0xAA, Buffer, (short)0x00, (short)(sCapacity - 1));
            }
            else if ((sCapacity > 0x81) && (sCapacity <= 0x102))
            {
                proHdlr.appendTLV((byte)0xAA, Buffer, (short)0x00, (short)(sCapacity - 2));
            }
            else if (sCapacity > 0x102)
            {
                proHdlr.appendTLV((byte)0xAA, Buffer, (short)0x00, (short)(sCapacity - 3));
            }
            bRes = false;
        }
        catch (ToolkitException e) {
            if(e.getReason()==ToolkitException.HANDLER_OVERFLOW)
                bRes = true ;
        }
        catch (Exception e)  {    
            bRes = false;
        }
        reportTestOutcome(testCaseNb, bRes) ;
    }
}
