//-----------------------------------------------------------------------------
//    API_2_PRH_GCAP_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_prh_gcap;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.ProactiveResponseHandler.getCapacity()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_PRH_GCAP_1  extends TestToolkitApplet
{

    // Number of tests
    byte testCaseNb = (byte) 0x00;
    private final byte textBuffer[] = {(byte)'T',(byte)'e',(byte)'x',(byte)'t'}; 
        
	/**
     * Constructor of the applet
     */
    public API_2_PRH_GCAP_1 () 
    {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_PRH_GCAP_1  thisApplet = new API_2_PRH_GCAP_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes = false;
        
        // results of methods
        short sLength = 0;
        short sCapacity = 0;
                
        // Get the system instance of handlers
		ProactiveHandler proHdlr = ProactiveHandler.getTheHandler();
        ProactiveResponseHandler proRespHdlr = null ;
       
        // Init and send a Display Test proactive command
        proHdlr.initDisplayText((byte)0x00, DCS_8_BIT_DATA, textBuffer, (short)0, (short)textBuffer.length);
        proHdlr.send();
        
        // Get the response handler
		proRespHdlr = ProactiveResponseHandler.getTheHandler();
	    
	    // Get length of the proactive response handler
		bRes = false;
		testCaseNb = (byte)0x01;
	    try {
	        sLength = proRespHdlr.getLength();
	        bRes = true;
	    }
		catch (Exception e)  {    
			bRes = false;
    	}
		reportTestOutcome(testCaseNb, bRes) ;
    	
    	// get capacity of the proactive response handler
		bRes = false;
		testCaseNb = (byte)0x02;
	    try {
	        sCapacity = proRespHdlr.getCapacity();
	        bRes = true;
	    }
		catch (Exception e)  {    
			bRes = false;
    	}
		reportTestOutcome(testCaseNb, bRes) ;
    	
        // Capacity must be greater than length of proactive response handler
		bRes = false;
		testCaseNb = (byte)0x03;
        if (sCapacity >= sLength)
        {
			bRes = true;
        }
        else
        {
	        bRes = false;
        }
		reportTestOutcome(testCaseNb, bRes) ;
	}
}
