//-----------------------------------------------------------------------------
//    API_2_TKR_SEVL_BSS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_sevl_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.setEventList(byte[] eventList,
 *                                                      short offset,
 *                                                      short length) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_TKR_SEVL_BSS_1 extends TestToolkitApplet {

    // Not allowed events for the setEvent() method
    private static byte[] NOT_ALLOWED_SET_EVENTS = 
                                                {EVENT_MENU_SELECTION,
                                                    EVENT_MENU_SELECTION_HELP_REQUEST,
                                                        EVENT_TIMER_EXPIRATION,
                                                            EVENT_STATUS_COMMAND};

    // Not supported events for the setEvent() method
    private static short NOT_SUPPORTED_SETEVENT_0 = 0;
    
    private static short SUPPORTED_SETEVENT_INTERVAL_MAX = 24;
    private static short SUPPORTED_SETEVENT_INTERVAL_MIN = -1;

    // Event value range
    private    static short MIN_EVENT_NB = -1;
    private    static short MAX_EVENT_NB = 24;

    // Events allowed and supported
    private static short offset = 5;
    private static short MAX_EVENT = 22; // 26 events(-1, 1 to 24, 127) - 4 events not allowed
    private byte [] EventList = new byte[MAX_EVENT];

    // Events allocated only for 1 applet
    private byte [] List = {EVENT_CALL_CONTROL_BY_SIM, EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM};

    private byte [] MonoEventList = new byte [1];

    /**
     * Constructor of the applet
     */
    public API_2_TKR_SEVL_BSS_1() {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) {
        // Create a new applet instance
        API_2_TKR_SEVL_BSS_1 thisApplet = new API_2_TKR_SEVL_BSS_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }

     /**
      * Method called by the processToolkit to know if event
      * is an allowed event for the clearEvent() or setEvent() method
      */
    private boolean isEventAllowed(byte event) {
        boolean allowed = true;

        for(short i = ((short) (NOT_ALLOWED_SET_EVENTS.length-1));
            ((i > (short) -1) && (allowed));i--) {
            allowed = (NOT_ALLOWED_SET_EVENTS[i] != event);
        }
        return allowed;
    }

     /**
      * Method called by the processToolkit to know if event
      * is a supported event for the setEvent() method
      */
    private boolean isEventSupported(byte event) {
        return (((event != NOT_SUPPORTED_SETEVENT_0)
                && (event >= SUPPORTED_SETEVENT_INTERVAL_MIN)
                && (event <= SUPPORTED_SETEVENT_INTERVAL_MAX))
                || (event == EVENT_FIRST_COMMAND_AFTER_SELECT));
            //check if event is not equals to
            //a not supported event (Intervale of values)
    }

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) {
        // Result of tests
        boolean bRes;

        // Number of tests
        byte testCaseNb = (byte) 0x12;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler();

        ProactiveResponseHandler proRespHdlr = null;

        short i;
        short j;
        

        if (event == EVENT_FORMATTED_SMS_PP_ENV) {

            j = 0;
            
            //Build the allowed and supported events list
            for(i = MIN_EVENT_NB; i <= MAX_EVENT_NB;i++) {
            
                if ((this.isEventAllowed((byte) i))
                    && (this.isEventSupported((byte) i))) {
                        
                    EventList[j] = (byte) i;
                    j++;
                }
            }
            EventList[j] = (byte) EVENT_FIRST_COMMAND_AFTER_SELECT;


            // -----------------------------------------------------------------
            // Test Case 1 :Applet registering all eventList buffer
            //              EVENT_UNRECOGNIZED_ENVELOPE,
            //              EVENT_PROFILE_DOWNLOAD,
            //              EVENT_FORMATTED_SMS_PP_END,
            //              EVENT_FORMATTED_SMS_PP_UPD,
            //              EVENT_FORMATTED_SMS_CB, 
            //              EVENT_UNFORMATTED_SMS_PP_END,
            //              EVENT_UNFORMATTED_SMS_PP_UPD,
            //              EVENT_UNFORMATTED_SMS_CB,
            //              EVENT_CALL_CONTROL_BY_SIM,
            //              EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,
            //              EVENT_EVENT_DOWNLOAD_MT_CALL,
            //              EVENT_EVENT_DOWNLOAD_CALL_CONNECTED,
            //              EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED,
            //              EVENT_EVENT_DOWNLOAD_LOCATION_STATUS,
            //              EVENT_EVENT_DOWNLOAD_USER_ACTIVITY,
            //              EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE,
            //              EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS,
            //              EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION,
            //              EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION,
            //              EVENT_EVENT_DOWNLOAD_DATA_AVAILABLE,
            //              EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS,
            //              EVENT_FIRST_COMMAND_AFTER_SELECT
            //
            //              1 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            //
            //              2 - setEventList(eventList)
            //                  Offset = 0
            //                  Length = eventList.lentgh
            //                  No exception shall be thrown
            //
            //              3 - For all events in eventList isEventSet(event)
            //                  Each time shall return true
            //
            //              4 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
        
            testCaseNb = (byte) 1;
            
            bRes = false; 

            // -----------------------------------------------------------------
            //              1 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
            try {
                for( j = (short)0; (j < MAX_EVENT); j++) {
                    obReg.clearEvent(EventList[j]);
                }
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            // -----------------------------------------------------------------
            //              2 - setEventList(eventList)
            //                  Offset = 0
            //                  Length = eventList.lentgh
            //                  No exception shall be thrown
            // -----------------------------------------------------------------

            try {
                obReg.setEventList(EventList, (short) 0, MAX_EVENT);
            }
            catch (Exception e) {
                bRes = false;
            }

            // -----------------------------------------------------------------
            //              3 - For all events in eventList isEventSet(event)
            //                  Each time shall return true
            // -----------------------------------------------------------------
            for( j = (short) 0; (j < MAX_EVENT) && bRes; j++) {
                bRes = obReg.isEventSet(EventList[j]);
            }
            
            // -----------------------------------------------------------------
            //              4 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
            try {
                for( j = (short) 0; (j < MAX_EVENT) && bRes; j++) {
                    obReg.clearEvent(EventList[j]);
                }
            }
            catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);


            // -----------------------------------------------------------------
            // Test Case 2 :Registering part of eventList buffer
            //              1 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            //
            //              2 - setEventList(eventList)
            //                  Offset > 0
            //                  Length = eventList.lentgh - offset
            //                  No exception shall be thrown
            //
            //              3 - For all events in eventList isEventSet(event)
            //                  Each time shall return true for events 
            //                  ranging from offset to offset+length 
            //                  else shall return false
            //
            //              4 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
            
            testCaseNb = (byte) 2;    
            bRes = false;

            // -----------------------------------------------------------------
            //              1 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
            try {
                for( j = (short) 0;(j < MAX_EVENT);j++) {
                    obReg.clearEvent(EventList[j]);
                }
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            // -----------------------------------------------------------------
            //              2 - setEventList(eventList)
            //                  Offset > 0
            //                  Length = eventList.lentgh - offset
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
            try {
                obReg.setEventList(EventList, offset, (short) (MAX_EVENT-offset));
            }
            catch (Exception e) {
                bRes = false;
            }

            // -----------------------------------------------------------------
            //              3 - For all events in eventList isEventSet(event)
            //                  Each time shall return true for events 
            //                  ranging from offset to offset+length 
            // -----------------------------------------------------------------
            for ( j = (short) 0; (j < offset) && bRes; j++) {

                bRes = !obReg.isEventSet(EventList[j]);
            }

            // -----------------------------------------------------------------
            //              3 - else shall return false
            // -----------------------------------------------------------------
            for( j = offset;(j < MAX_EVENT) && bRes;j++) {

                bRes = obReg.isEventSet(EventList[j]);
            }

            // -----------------------------------------------------------------
            //              4 - For each event in EventList clearEvent(event)
            //                  No exception shall be thrown
            // -----------------------------------------------------------------
            try {
                for( j = (short) 0;(j < MAX_EVENT) && bRes;j++) {
                    
                    bRes = false;
                    obReg.clearEvent(EventList[j]);
                    bRes = true;
                }
            }
            catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);

            // -----------------------------------------------------------------
            // Test Case 3 :    Null buffer
            //                  EventList = null 
            //                  Shall throw a 
            //                  java.lang.NullPointerException Exception
            // -----------------------------------------------------------------
            
            testCaseNb = (byte) 3;
            bRes = false;

            try {
                obReg.setEventList(null, (short) 0, (short) 1);
            }
            catch (java.lang.NullPointerException e){
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);

            // -----------------------------------------------------------------
            // Test Case 4 :    Out of bounds offset
            //                  Offset = eventList.length
            //                  Length = 1
            //                  Shall throw a java.lang.ArrayIndexOutOfBounds Exception
            // -----------------------------------------------------------------

            testCaseNb = (byte) 4;
            bRes = false;

            try {
                obReg.setEventList(EventList, MAX_EVENT, (short) 1);
            }
            catch (java.lang.ArrayIndexOutOfBoundsException e) {
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);

            // -----------------------------------------------------------------        
            // Test Case 5 :    Out of bounds and big offset
            //                  Offset = 255
            //                  Length = 1
            //                  Shall throw a java.lang.ArrayIndexOutOfBounds Exception
            // -----------------------------------------------------------------

            testCaseNb = (byte) 5;
            bRes = false;

            try {
                obReg.setEventList(EventList, (short) 255, (short) 1);
            }
            catch (java.lang.ArrayIndexOutOfBoundsException e) {
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);

            // -----------------------------------------------------------------                                    
            // Test Case 6 :    Offset < 0
            //                  Offset = -1
            //                  Length = 1
            //                  Shall throw a java.lang.ArrayIndexOutOfBounds Exception
            // -----------------------------------------------------------------

            testCaseNb = (byte) 6;
            bRes = false;

            try {
                obReg.setEventList(EventList, (short) -1, (short) 1);
            }
            catch (java.lang.ArrayIndexOutOfBoundsException e) {
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);

            // -----------------------------------------------------------------
            // Test Case 7 :    Out of bounds length
            //                  Offset = 0
            //                  Length = eventList.length + 1
            //                  Shall throw a java.lang.ArrayIndexOutOfBounds Exception
            // -----------------------------------------------------------------
            
            testCaseNb = (byte) 7;
            bRes = false;

            try {
                obReg.setEventList(EventList, (short) 0, (short) (MAX_EVENT + 1));
            }
            catch (java.lang.ArrayIndexOutOfBoundsException e) {
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            // -----------------------------------------------------------------
            //                  clearEvent() of all the possible events
            //                  to be sure that no one of then is set.
            // -----------------------------------------------------------------
            for ( j = (short) 0;(j < MAX_EVENT);j++) {

                obReg.clearEvent(EventList[j]);
            }

            reportTestOutcome(testCaseNb, bRes);

            // -----------------------------------------------------------------
            // Test Case 8 :    Out of bounds and big length
            //                  Offset = 0
            //                  Length = 255
            //                  Shall throw a java.lang.ArrayIndexOutOfBounds Exception
            // -----------------------------------------------------------------

            testCaseNb = (byte) 8;
            bRes = false;

            try {
                obReg.setEventList(EventList, (short) 0, (short) 255);
            }
            catch (Exception e) {
                bRes = true;
            }

            // -----------------------------------------------------------------
            //                  clearEvent() of all the possible events
            //                  to be sure that no one of then is set.
            // -----------------------------------------------------------------
            for ( j = (short) 0;(j < MAX_EVENT);j++) {
                
                obReg.clearEvent(EventList[j]);
            }

            reportTestOutcome(testCaseNb, bRes);

            // -----------------------------------------------------------------
            // Test Case 9 :    Length < 0
            //                  Offset = 0
            //                  Length = -1
            //                  Shall throw a java.lang.ArrayIndexOutOfBounds Exception
            // -----------------------------------------------------------------

            testCaseNb = (byte) 9;
            bRes = false;

            try {
                obReg.setEventList(EventList, (short) 0, (short) -1);
            }
            catch (java.lang.ArrayIndexOutOfBoundsException e) {
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);


            // -----------------------------------------------------------------    
            // Test Case 10 :    Out of bounds offset + Length 
            //                   Offset + length > eventList.length + 1
            //                   Shall throw a java.lang.ArrayIndexOutOfBounds Exception
            // -----------------------------------------------------------------

            testCaseNb = (byte) 10;
            bRes = false;

            try {
                obReg.setEventList(EventList, offset, MAX_EVENT);
            }
            catch (java.lang.ArrayIndexOutOfBoundsException e) {
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            // -----------------------------------------------------------------
            //                  clearEvent() of all the possible events
            //                  to be sure that no one of then is set.
            // -----------------------------------------------------------------
            for ( j = (short) 0;(j < MAX_EVENT);j++) {

                obReg.clearEvent(EventList[j]);
            }

            reportTestOutcome(testCaseNb, bRes);

            // -----------------------------------------------------------------
            // Test Case 11 :    Event 0
            //                   Call setEventList with eventList indicating event 0
            //                   Shall throw a ToolkitException with EVENT_NOT_SUPPORTED reason code    
            // -----------------------------------------------------------------
            
            testCaseNb = (byte) 11;
            bRes = false;

            MonoEventList[(short) 0] = (byte) 0;

            try {
                obReg.setEventList(MonoEventList, (short) 0, (short) 1);
            }
            catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.EVENT_NOT_SUPPORTED);
            }
            catch (Exception e) {
                bRes = false;
            }
            
            reportTestOutcome(testCaseNb, bRes);


            // -----------------------------------------------------------------
            // Test Cases 12 to 15
            //
            // Test Case 12 :    EVENT_MENU_SELECTION
            //                   Shall throw a ToolkitException 
            //                   with EVENT_NOT_ALLOWED reason code
            //
            // Test Case 13 :    EVENT_MENU_SELECTION_HELP_REQUEST
            //                   Shall throw a ToolkitException 
            //                   with EVENT_NOT_ALLOWED reason code    
            //
            // Test Case 14 :    EVENT_TIMER_EXPIRATION
            //                   Shall throw a ToolkitException 
            //                   with EVENT_NOT_ALLOWED reason code
            //
            // Test Case 15 :    EVENT_STATUS_COMMAND
            //                   Shall throw a ToolkitException 
            //                   with EVENT_NOT_ALLOWED reason code
            // -----------------------------------------------------------------
            
            for (j = (short) 0; (j < (short) NOT_ALLOWED_SET_EVENTS.length); j++) {

                    MonoEventList[(short) 0] = NOT_ALLOWED_SET_EVENTS[j];
                    bRes = false;
                    try {
                        obReg.setEventList(MonoEventList, (short) 0, (short) 1);
                    }
                    catch (ToolkitException e) {
                        bRes = (e.getReason()==ToolkitException.EVENT_NOT_ALLOWED);
                    }
                    catch (Exception e) {
                        bRes = false;
                    }

                    testCaseNb = (byte) (testCaseNb + 1); // Test Cases : 12-15
                    reportTestOutcome(testCaseNb, bRes);
            }

            // -----------------------------------------------------------------
            // Test Case 16 :    Setting EVENT_CALL_CONTROL_BY_SIM &
            //                   EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
            //                   Shall not throw an exception             
            // -----------------------------------------------------------------
            
            testCaseNb = (byte) 16;
            bRes = false;

            try {
                obReg.setEventList(List, (short) 0, (short) 2);
                bRes = true;
            }
            catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);

            // -----------------------------------------------------------------
            // Test Cases 17 & 18 : by default    
            // -----------------------------------------------------------------

            testCaseNb = (byte) 17;
            reportTestFailure(testCaseNb);

            testCaseNb = (byte) 18;
            reportTestFailure(testCaseNb);
            

        } else {

            if (event == EVENT_CALL_CONTROL_BY_SIM) {

            // -----------------------------------------------------------------
            // Test Case 17 :    Check applet is triggered by an 
            //                   ENVELOPE(EVENT_CALL_CONTROL_BY_SIM)
            // -----------------------------------------------------------------
                testCaseNb = (byte) 17;
                reportTestSuccess(testCaseNb);
            } else {
                if (event == EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM) {

            // -----------------------------------------------------------------
            // Test Case 18 :    Check applet is triggered by an 
            //                   ENVELOPE(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM)
            // -----------------------------------------------------------------
                    testCaseNb = (byte) 18;
                    reportTestSuccess(testCaseNb);
                }
            }
        }
    }
}
