//-----------------------------------------------------------------------------
//    API_2_TKR_SEVL_BSS_3.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_sevl_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.setEventList(byte[] eventList,
 *                                                      short offset,
 *                                                      short length) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_TKR_SEVL_BSS_3 extends TestToolkitApplet {

    private static byte[] baList1 = {EVENT_FORMATTED_SMS_PP_ENV, EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_UNFORMATTED_SMS_PP_ENV};
    private static byte[] baList2 = {EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_FORMATTED_SMS_PP_UPD, EVENT_UNFORMATTED_SMS_PP_ENV};
    private static byte[] baList3 = {EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_FORMATTED_SMS_CB};
    private static byte[] baList4 = {EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_UNFORMATTED_SMS_PP_ENV};

    /**
     * Constructor of the applet
     */
    public API_2_TKR_SEVL_BSS_3() {
        // register to EVENT_UNFORMATTED_SMS_CB
        obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
    }

    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) {
        // Create a new applet instance
        API_2_TKR_SEVL_BSS_3 thisApplet = new API_2_TKR_SEVL_BSS_3();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();
    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) {
        // Result of tests
        boolean bRes ;

        // Number of tests
        byte testCaseNb;

        // -----------------------------------------------------------------
		// Test Case 21 : no TAR defined
		// -----------------------------------------------------------------
        
        // 1- Applet is triggered by EVENT_UNFORMATTED_SMS_CB
        testCaseNb = (byte)0x01;
        bRes = true;
        reportTestOutcome(testCaseNb, bRes);

        // 2- setEventList
        testCaseNb = (byte)0x02;
        try {
            obReg.setEventList(baList1, (short)0, (short)baList1.length);
        }
        catch (ToolkitException e) {	
		    bRes = (e.getReason()==ToolkitException.TAR_NOT_DEFINED);
		}
        reportTestOutcome(testCaseNb, bRes);

        // 3- setEventList
        testCaseNb = (byte)0x03;
        try {
            obReg.setEventList(baList2, (short)0, (short)baList2.length);
        }
        catch (ToolkitException e) {	
		    bRes = (e.getReason()==ToolkitException.TAR_NOT_DEFINED);
		}
        reportTestOutcome(testCaseNb, bRes);

        // 4- setEventList
        testCaseNb = (byte)0x04;
        try {
            obReg.setEventList(baList3, (short)0, (short)baList3.length);
        }
        catch (ToolkitException e) {	
		    bRes = (e.getReason()==ToolkitException.TAR_NOT_DEFINED);
		}
        reportTestOutcome(testCaseNb, bRes);

        // 5- isEventSet(EVENT_UNFORMATTED_SMS_PP_ENV)
        //    shall return false
        testCaseNb = (byte)0x05;
        bRes = !obReg.isEventSet(EVENT_UNFORMATTED_SMS_PP_ENV);
        reportTestOutcome(testCaseNb, bRes);

        // 6- isEventSet(EVENT_UNFORMATTED_SMS_PP_UPD)
        //    shall return false
        testCaseNb = (byte)0x06;
        bRes = !obReg.isEventSet(EVENT_UNFORMATTED_SMS_PP_UPD);
        reportTestOutcome(testCaseNb, bRes);

        // 7- isEventSet(EVENT_FORMATTED_SMS_PP_ENV)
        //    shall return false
        testCaseNb = (byte)0x07;
        bRes = !obReg.isEventSet(EVENT_FORMATTED_SMS_PP_ENV);
        reportTestOutcome(testCaseNb, bRes);

        // 8- isEventSet(EVENT_FORMATTED_SMS_PP_UPD)
        //    shall return false
        testCaseNb = (byte)0x08;
        bRes = !obReg.isEventSet(EVENT_FORMATTED_SMS_PP_UPD);
        reportTestOutcome(testCaseNb, bRes);

        // 9- isEventSet(EVENT_FORMATTED_SMS_CB_ENV)
        //    shall return false
        testCaseNb = (byte)0x09;
        bRes = !obReg.isEventSet(EVENT_FORMATTED_SMS_CB);
        reportTestOutcome(testCaseNb, bRes);

        // -----------------------------------------------------------------
		// Test Case 22
		// -----------------------------------------------------------------

        // 1- setEventList(EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_UNFORMATTED_SMS_PP_ENV)
        //    No exception shall be thrown
        testCaseNb = (byte)0x0A;
        try {
            obReg.setEventList(baList4, (short)0, (short)baList4.length);
            bRes = true;
        }
        catch (ToolkitException e) {	
		    bRes = false;
		}
        reportTestOutcome(testCaseNb, bRes);

        // 2- isEventSet(EVENT_UNFORMATTED_SMS_PP_ENV)
        //    method should return true
        testCaseNb = (byte)0x0B;
        bRes = obReg.isEventSet(EVENT_UNFORMATTED_SMS_PP_ENV);
        reportTestOutcome(testCaseNb, bRes);

    }
}
