//-----------------------------------------------------------------------------
//    API_2_TKR_SEVTB_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_sevtb;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.setEvent(byte event) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_TKR_SEVTB_1 extends TestToolkitApplet {
	
	//Not allowed events for the setEvent() method
	private static byte[] NOT_ALLOWED_SET_EVENTS = 
												{EVENT_MENU_SELECTION,
													EVENT_MENU_SELECTION_HELP_REQUEST,
														EVENT_TIMER_EXPIRATION,
															EVENT_STATUS_COMMAND};

	
	//Not supported events for the setEvent() method
	private static short NOT_SUPPORTED_SETEVENT_0 = 0;
	private static short SUPPORTED_SETEVENT_INTERVAL_MAX = 24;
	private static short SUPPORTED_SETEVENT_INTERVAL_MIN = -1;

	//Event value range
	private	static short MIN_EVENT_NB = -1;
	private	static short MAX_EVENT_NB = 24;

    // Events allowed and supported
	private static short MAX_EVENT = 22; // 26 events(-1, 1 to 24, 127) - 4 events not allowed
	private byte [] EventList = new byte[MAX_EVENT];

    /**
     * Constructor of the applet
     */
    public API_2_TKR_SEVTB_1() {
    }

    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) {
        // Create a new applet instance
        API_2_TKR_SEVTB_1 thisApplet = new API_2_TKR_SEVTB_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

	 /**
      * Method called by the processToolkit to know if event
	  * is an allowed event for the clearEvent() or setEvent() method
      */
    private boolean isEventAllowed(byte event) {
		boolean allowed = true;

		for(short i = ((short) (NOT_ALLOWED_SET_EVENTS.length-1));
			((i > (short) -1) && (allowed));i--){
			allowed = (NOT_ALLOWED_SET_EVENTS[i] != event);
		}
		return allowed;
	}

	 /**
       * Method called by the processToolkit to know if event
	   * is a supported event for the setEvent() method
	   */
    private boolean isEventSupported(byte event) {
		return 	(((event != NOT_SUPPORTED_SETEVENT_0)
		      	&& (event >= SUPPORTED_SETEVENT_INTERVAL_MIN)
				&& (event <= SUPPORTED_SETEVENT_INTERVAL_MAX))
                || (event == EVENT_FIRST_COMMAND_AFTER_SELECT));	
			//check if event is not equals to
			//a not supported event (Interval of values)
	}

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) {
        // Result of tests
        boolean bRes ;

        // Number of tests
        byte testCaseNb = (byte) 0x0B;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;

        ProactiveResponseHandler proRespHdlr = null ;

		short i;
		byte eventID;


	if (event == EVENT_FORMATTED_SMS_PP_ENV) {

			// -----------------------------------------------------------------
			// Test Case 1 :Applet 1 is triggered by ENVELOPE(SMS_PP_FORMATTED) 
			//
			//				Because this applet does call setEvent() 
			//				during installation, if it is triggered, 
			//				it means setEvent() works for this event. 
			//				So Applet records it as result of test 1
			// -----------------------------------------------------------------

			testCaseNb = (byte) 1 ;
			reportTestSuccess(testCaseNb) ;


			// -----------------------------------------------------------------
			// Test Case 2 :For all events defined in GSM 43.019 and allowed :
			//				EVENT_UNRECOGNIZED_ENVELOPE,
			//				EVENT_PROFILE_DOWNLOAD,
			//				EVENT_FORMATTED_SMS_PP_ENV,
			//				EVENT_FORMATTED_SMS_PP_UPD,
			//				EVENT_FORMATTED_SMS_CB
			//				EVENT_UNFORMATTED_SMS_PP_ENV,
			//				EVENT_UNFORMATTED_SMS_PP_UPD,
			//				EVENT_UNFORMATTED_SMS_CB,
			//				EVENT_CALL_CONTROL_BY_SIM,
			//				EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,
			//				EVENT_EVENT_DOWNLOAD_MT_CALL,
			//				EVENT_EVENT_DOWNLOAD_CALL_CONNECTED,
			//				EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED,
			//				EVENT_EVENT_DOWNLOAD_LOCATION_STATUS,
			//				EVENT_EVENT_DOWNLOAD_USER_ACTIVITY,
			//				EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE,
			//				EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS
			//				EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION
			//				EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION
            //              EVENT_EVENT_DOWNLOAD_DATA_AVAILABLE
            //              EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS
            //              EVENT_FIRST_COMMAND_AFTER_SELECT
			//
			//				1 - clearEvent(event)
			//					No exception shall be thrown
			//
			//				2 - isEventSet(event)
			//					Shall return false
			//
			//				3 - setEvent(event)
			//					No exception shall be thrown
			//
			//				4 - isEventSet(event)
			//					Shall return true
			//
			//				5 - clearEvent(event)
			//					No exception shall be thrown
			// -----------------------------------------------------------------
        
			testCaseNb = (byte) 2 ;
			bRes = false;

			// -----------------------------------------------------------------
			// For all events defined in GSM 43.019 and allowed :	
			// -----------------------------------------------------------------
			try {     				
				for( i = 0; i < (short)(MAX_EVENT-1); i++) {
									
					bRes = false;
					
					if ((this.isEventAllowed(EventList[i]))
						&& (this.isEventSupported(EventList[i]))) {
						
			// -----------------------------------------------------------------
			//				1 - clearEvent(event)
			//					No exception shall be thrown
			// -----------------------------------------------------------------
						obReg.clearEvent(EventList[i]);

			// -----------------------------------------------------------------
			//				2 - isEventSet(event)
			//					Shall return false
			// -----------------------------------------------------------------
						if (obReg.isEventSet(EventList[i])) {
							bRes = false ;
							break;
						}

			// -----------------------------------------------------------------
			//				3 - setEvent(event)
			//					No exception shall be thrown
			// -----------------------------------------------------------------
						obReg.setEvent(EventList[i]);

			// -----------------------------------------------------------------
			//				4 - isEventSet(event)
			//					Shall return true
			// -----------------------------------------------------------------
						if (!obReg.isEventSet(EventList[i])) {
							bRes = false ;
							break;
						}

			// -----------------------------------------------------------------
			//				5 - clearEvent(event)
			//					No exception shall be thrown
			// -----------------------------------------------------------------
						obReg.clearEvent(EventList[i]);
						bRes = true;
                    } else {
						bRes = true;
					}
				}
			} 
			catch (Exception e) {	// No exception shall be thrown
				bRes = false ;
			}
			reportTestOutcome(testCaseNb, bRes) ;

			// -----------------------------------------------------------------
			// Test Case 3 :	Event 0
			//					Shall throw a ToolkitException 
			//					with EVENT_NOT_SUPPORTED reason code
			// -----------------------------------------------------------------
        
			testCaseNb = (byte) 3 ;
			bRes = false;

			try {    
				eventID = (byte) 0;
				obReg.setEvent(eventID);
			}
			catch (ToolkitException e) {	// Only EVENT_NOT_SUPPORTED should be thrown
				bRes = (e.getReason()==ToolkitException.EVENT_NOT_SUPPORTED);
			}
			catch (Exception e) {
				bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes) ;


			// -----------------------------------------------------------------
			// Test Cases 4 to 7 
			//
			// Test Case 4 :	Setting EVENT_MENU_SELECTION
			//					Shall throw a ToolkitException 
			//					with EVENT_NOT_ALLOWED reason code
			//
			// Test Case 5 :	Setting EVENT_MENU_SELECTION_HELP_REQUEST
			//					Shall throw a ToolkitException 
			//					with EVENT_NOT_ALLOWED reason code	
			//
			// Test Case 6 :	Setting EVENT_TIMER_EXPIRATION
			//					Shall throw a ToolkitException 
			//					with EVENT_NOT_ALLOWED reason code	
			//
			// Test Case 7 :	Setting EVENT_STATUS_COMMAND
			//					Shall throw a ToolkitException 
			//					with EVENT_NOT_ALLOWED reason code	
			// -----------------------------------------------------------------
         
			for( i = (short) (NOT_ALLOWED_SET_EVENTS.length-1);	(i > (short) -1); i--) {
				
				bRes = false;
				try {
					obReg.setEvent(NOT_ALLOWED_SET_EVENTS[i]);
				}
				catch (ToolkitException e) {	// Only EVENT_NOT_ALLOWED should be thrown
					bRes = (e.getReason()==ToolkitException.EVENT_NOT_ALLOWED);
				}
				catch (Exception e) {
					bRes = false;
				}

				testCaseNb = (byte) (testCaseNb + 1); // Test Cases: 4-7
				reportTestOutcome(testCaseNb, bRes) ;
			}	
			reportTestOutcome(testCaseNb, bRes) ;


			// -----------------------------------------------------------------
			// Test Case 8 :	Setting EVENT_CALL_CONTROL_BY_SIM 
			//					Shall not throw an exception
			// -----------------------------------------------------------------
			
			testCaseNb = (byte) 8 ;
			bRes = false;

			try {
				obReg.setEvent(EVENT_CALL_CONTROL_BY_SIM);
				bRes = true;
			}
			catch (Exception e) {	
				bRes = false;
			}
			reportTestOutcome(testCaseNb, bRes) ;


			// -----------------------------------------------------------------
			// Test Case 9 :	Setting EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM 
			//					Shall not throw an exception
			// -----------------------------------------------------------------
			
			testCaseNb = (byte) 9 ;

			bRes = false;

			try {
				obReg.setEvent(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM);
				bRes = true;
			}
			catch (Exception e) {	
				bRes = false;
			}
			reportTestOutcome(testCaseNb, bRes) ;


			// -----------------------------------------------------------------
			// Test Cases 10 & 11 : by default	
			// -----------------------------------------------------------------
        
			testCaseNb = (byte) 10 ;

			reportTestFailure(testCaseNb) ;

			testCaseNb = (byte) 11 ;
			reportTestFailure(testCaseNb) ;

		}
		else{
			
			if (event == EVENT_CALL_CONTROL_BY_SIM) {
				// -----------------------------------------------------------------
				// Test Case 10 :	Check applet is triggered 
				//					by an ENVELOPE(EVENT_CALL_CONTROL_BY_SIM)
				// -----------------------------------------------------------------
				
				testCaseNb = (byte) 10 ;
				reportTestSuccess(testCaseNb) ;

			}
			else
			{
				
				if (event == EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM) {
					// -----------------------------------------------------------------
					// Test Case 11 :	Check applet is triggered by an 
					//					ENVELOPE(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM)
					// -----------------------------------------------------------------

					testCaseNb = (byte) 11 ;
					reportTestSuccess(testCaseNb) ;
				}
			}
		}
	} 
}
