//-----------------------------------------------------------------------------
//    API_2_ENH_CPYVS_BSS_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_cpyvs_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;
//import javacard.framework.Util.* ;
/**
 * Test Area : sim.tookit.EnvelopeHandler.copyValue()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_ENH_CPYVS_BSS_1  extends TestToolkitApplet
{
	private final byte[] compBuffer = {(byte)0x81,(byte)0x11,(byte)0x22,(byte)0x33,(byte)0x44,(byte)0xF5};
	private final byte[] compBuffer2= {(byte)0x55,(byte)0x55,(byte)0x55,(byte)0x11,(byte)0x22,(byte)0x33,(byte)0x44,(byte)0x55,(byte)0x55,(byte)0x55,
                                       (byte)0x55,(byte)0x55,(byte)0x55,(byte)0x55,(byte)0x55,(byte)0x55,(byte)0x55,(byte)0x55,(byte)0x55,(byte)0x55};
	private byte[] compBuffer3;
	private final byte[] Header0348 = {(byte)0x02,(byte)0x70,(byte)0x00,(byte)0x01,(byte)0x08,(byte)0x0D,(byte)0x08,(byte)0x00,
	                                   (byte)0x00,(byte)0x00,(byte)0x28,(byte)0x84,(byte)0x85,(byte)0x00,(byte)0x00,(byte)0x00,
	                                   (byte)0x00,(byte)0x01,(byte)0x00};
	private byte[] dstBuffer;

    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public API_2_ENH_CPYVS_BSS_1 () 
    {
       //register to EVENT_UNFORMATTED_SMS_PP_ENV
       obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_CPYVS_BSS_1  thisApplet = new API_2_ENH_CPYVS_BSS_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
		ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    switch ( testCaseNb ) 
		{
			case (byte) 0 : 
				// --------------------------------------------
				// Test Case 1 : try to use the copyValue method with an destination Buffer null
				testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV((byte)2,(byte)1)==TLV_FOUND_CR_SET)
						&&(envHdlr.copyValue((short)0,null,(short)0,(short)1)==0))
							bRes = false;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (NullPointerException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 1 : 
				// --------------------------------------------
				// Test Case 2 : use the copyValue method with an offset > buffer length
				testCaseNb = (byte) 2 ;

				bRes = false ;
				dstBuffer =new byte[5];
				try {
					if((envHdlr.findTLV((byte)0x0B,(byte)1)==TLV_FOUND_CR_SET)
						&&(envHdlr.copyValue((short)0,dstBuffer,(short)5,(short)1)==0))
							bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 2 : 
				// --------------------------------------------
				// Test Case 3 : use the copyValue method with an offset = -1
				testCaseNb = (byte) 3 ;

				bRes = false ;
				dstBuffer =new byte[5];
				try {
					if((envHdlr.findTLV((byte)0x0B,(byte)1)==TLV_FOUND_CR_SET)
						&&(envHdlr.copyValue((short)0,dstBuffer,(short)-1,(short)1)==0))
							bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		
			case (byte) 3 : 
				// --------------------------------------------
				// Test Case 4 : use the copyValue method with an length > buffer length
				testCaseNb = (byte) 4 ;
				
				bRes = false ;
				dstBuffer =new byte[5];
				try {
					if((envHdlr.findTLV((byte)0x33,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)0,dstBuffer,(short)0,(short)6)==6))
							bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 4 : 
				// --------------------------------------------
				// Test Case 5 : use the copyValue method with an Offset + length > buffer length
				testCaseNb = (byte) 5 ;
				
				bRes = false ;
				dstBuffer =new byte[5];
				try {
					if((envHdlr.findTLV((byte)0x33,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)0,dstBuffer,(short)3,(short)3)==6))
							bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 5 : 
				// --------------------------------------------
				// Test Case 6 : use the copyValue method with an Offset + length > buffer length
				testCaseNb = (byte) 6 ;
				
				bRes = false ;
				dstBuffer =new byte[5];
				try {
					if((envHdlr.findTLV((byte)0x33,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)0,dstBuffer,(short)0,(short)-1)==0))
							bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 6 : 
				// --------------------------------------------
				// Test Case 7 : use the copyValue method with ValueOffset  > TLV length
				testCaseNb = (byte) 7 ;
				
				bRes = false ;
				dstBuffer =new byte[15];
				try {
					if((envHdlr.findTLV((byte)0x06,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)6,dstBuffer,(short)0,(short)1)==0))
							bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 7 : 
				// --------------------------------------------
				// Test Case 8 : use the copyValue method with ValueOffset  <0
				testCaseNb = (byte) 8 ;
				
				bRes = false ;
				dstBuffer =new byte[15];
				try {
					if((envHdlr.findTLV((byte)0x06,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)-1,dstBuffer,(short)0,(short)1)==0))
							bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 8 : 
				// --------------------------------------------
				// Test Case 9 : use the copyValue method with dstlength  > TLV length
				testCaseNb = (byte) 9 ;
				
				bRes = false ;
				dstBuffer =new byte[15];
				try {
					if((envHdlr.findTLV((byte)0x06,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)0,dstBuffer,(short)0,(short)7)==0))
							bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 9 : 
				// --------------------------------------------
				// Test Case 10 : use the copyValue method with ValueOffset+dstlength  > TLV length
				testCaseNb = (byte) 10 ;
				
				bRes = false ;
				dstBuffer =new byte[15];
				try {
					if((envHdlr.findTLV((byte)0x06,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)2,dstBuffer,(short)0,(short)5)==0))
							bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 10 : 
				// --------------------------------------------
				// Test Case 11 : use the copyValue method without current TVL
				testCaseNb = (byte) 11 ;
				
				bRes = false ;
				dstBuffer =new byte[15];
				try {
					if((envHdlr.findTLV((byte)0x01,(byte)1)==TLV_NOT_FOUND)
						&&(envHdlr.copyValue((short)2,dstBuffer,(short)0,(short)5)==0))
							bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.UNAVAILABLE_ELEMENT)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 11 : 
				// --------------------------------------------
				// Test Case 12 : use successfully the copyValue method 
				testCaseNb = (byte) 12 ;
				
				bRes = false ;
				dstBuffer =new byte[6];
				try {
					if((envHdlr.findTLV((byte)0x06,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)0,dstBuffer,(short)0,(short)6)==6))
							bRes = true;
				}
				catch (ToolkitException e)    {    
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 12 : 
				// --------------------------------------------
				// Test Case 13 : use successfully the copyValue method and compare the received data
				testCaseNb = (byte) 13 ;
				
				bRes = false ;
				dstBuffer =new byte[6];
				try {
					if((envHdlr.findTLV((byte)0x06,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)0,dstBuffer,(short)0,(short)6)==6)
						&&(Util.arrayCompare(dstBuffer,(short)0,compBuffer,(short)0, (short) compBuffer.length)==0)) 
						bRes = true;
				}
				catch (ToolkitException e)    {    
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 13 : 
				// --------------------------------------------
				// Test Case 14 : use successfully the copyValue
				testCaseNb = (byte) 14 ;
				
				bRes = false ;
				dstBuffer =new byte[20];
				
				// initialize the buffer
				for(byte i=0;i<20;i++)
					dstBuffer[i] =(byte)0x55;
				
				try {
					if((envHdlr.findTLV((byte)0x06,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)1,dstBuffer,(short)3,(short)4)==7))
						bRes = true;
				}
				catch (ToolkitException e)    {    
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 14 : 
				// --------------------------------------------
				// Test Case 15 : use successfully the copyValue method and compare the received data
				testCaseNb = (byte) 15 ;
				
				bRes = false ;
				dstBuffer =new byte[20];
				
				// initialize the buffer
				for(byte i=0;i<20;i++)
					dstBuffer[i] =(byte)0x55;
				
				try {
					if((envHdlr.findTLV((byte)0x06,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)1,dstBuffer,(short)3,(short)4)==7)
						&&(Util.arrayCompare(dstBuffer,(short)0,compBuffer2,(short)0, (short) compBuffer2.length)==0)) 
						bRes = true;
				}
				catch (ToolkitException e)    {    
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 15 : 
				// --------------------------------------------
				// Test Case 16 : use successfully the copyValue method with the length of the copy =0
				testCaseNb = (byte) 16 ;
				
				bRes = false ;
				try {
					if((envHdlr.findTLV((byte)0x06,(byte)1)==TLV_FOUND_CR_NOT_SET)
						&&(envHdlr.copyValue((short)0,dstBuffer,(short)dstBuffer.length,(short)0)==dstBuffer.length))
							bRes = true;
				}
				catch (ToolkitException e)    {    
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 16 : 
				// --------------------------------------------
				// Test Case 17 : use successfully the copyValue method 
				testCaseNb = (byte) 17 ;
				
				bRes = false ;
				dstBuffer = new byte[0x10D];

				try {
					if((envHdlr.findTLV((byte)TAG_SMS_TPDU,(byte)1)!=TLV_NOT_FOUND)
						&&(envHdlr.copyValue((short)0x11,dstBuffer,(short)0,(short)0x10D)==0x10D))
							bRes = true;
				}
				catch (ToolkitException e)    {    
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			case (byte) 17 : 
				// --------------------------------------------
				// Test Case 18 : use successfully the copyValue method and compare the received data
				testCaseNb = (byte) 18 ;
				
				bRes = false ;

				compBuffer3 = new byte[0x10D];
				// initialise compBuffer3
				// 0348 header
				Util.arrayCopyNonAtomic(Header0348,(short)0, compBuffer3, (short)0x00, (short)0x13);
				// data
				for (short i = 0x13; i < 0x10D; i++)
				    compBuffer3[i] = (byte)(i-0x12);
				    
				try {
					if((envHdlr.findTLV((byte)TAG_SMS_TPDU,(byte)1)!=TLV_NOT_FOUND)
						&&(envHdlr.copyValue((short)0x11,dstBuffer,(short)0,(short)0x10D)==0x10D)
						&&(Util.arrayCompare(dstBuffer,(short)0,compBuffer3,(short)0, (short)0x10D)==0)) 
						bRes = true;
				}
				catch (ToolkitException e)    {    
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			case (byte) 18 : 
				// --------------------------------------------
				// Test Case 19 : use successfully the copyValue
				testCaseNb = (byte) 19 ;
				
				bRes = false ;
				
				// initialize the buffer
				for(short i=0;i<0x10D;i++)
				{
					dstBuffer[i] = (byte)0x55;
				}
				
				try {
					if((envHdlr.findTLV((byte)TAG_SMS_TPDU,(byte)1)!=TLV_NOT_FOUND)
						&&(envHdlr.copyValue((short)0x111,dstBuffer,(short)0x100,(short)0x0D)==0x10D))
						bRes = true;
				}
				catch (ToolkitException e)    {    
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			case (byte) 19 : 
				// --------------------------------------------
				// Test Case 20 : use successfully the copyValue method and compare the received data
				testCaseNb = (byte) 20 ;
				
				bRes = false ;

				// initialize the buffers
				for (short i=0;i<0x10D;i++)
				{
					dstBuffer[i] = (byte)0x55;
					compBuffer3[i] = (byte)0x55;
				}
				for(short i=0x100; i<0x10D;i++)
				{
					compBuffer3[i] = (byte)(i-0x12);
				}
				
				try {
					if((envHdlr.findTLV((byte)TAG_SMS_TPDU,(byte)1)!=TLV_NOT_FOUND)
						&&(envHdlr.copyValue((short)0x111,dstBuffer,(short)0x100,(short)0x0D)==0x10D)
						&&(Util.arrayCompare(dstBuffer,(short)0,compBuffer3,(short)0, (short)0x10D)==0)) 
						bRes = true;
				}
				catch (ToolkitException e)    {    
					bRes = false;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
		}
	}
}
