//-----------------------------------------------------------------------------
//    API_2_ENH_GIID_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_giid;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeHandler.getItemIdentifier
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 28/07/00
 *
 */
public class API_2_ENH_GIID_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;
	
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};

    // Number of tests
    byte testCaseNb = (byte) 0x00 ;


    /**
     * Constructor of the applet
     */
    public API_2_ENH_GIID_1() 
    {
	
		
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_GIID_1  thisApplet = new API_2_ENH_GIID_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
		switch ( testCaseNb ) {
		
			case (byte) 0 :
				// --------------------------------------------
				// Test Case 1 : get item identifier value is 03
				testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					if (envHdlr.getItemIdentifier() == (byte) 0x03)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			break;

			case (byte) 1 :
				// --------------------------------------------
				// Test Case 2 : Receive envelope with two item identifier TLV with first value FF and second 44
				//               method must return FF
				testCaseNb = (byte) 2 ;

				bRes = false ;
				try {
					if (envHdlr.getItemIdentifier() == (byte) 0xFF)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			break;

			case (byte) 2 :
				// --------------------------------------------
				// Test Case 3 : Receive envelope with two item identifier TLV with first value 81 and second 44, call twice the method getItemIdentifier
				//               method must always return 81
				testCaseNb = (byte) 3 ;

				bRes = false ;
				try {
					if ((envHdlr.getItemIdentifier() == (byte) 0x81) && (envHdlr.getItemIdentifier() == (byte) 0x81) )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			break;

			case (byte) 3 :
				// --------------------------------------------
				// Test Case 4 : Receive envelope with item identifier TLV and value of 66. FindTLV with TAG 02. getItemIdentifier and after getValueByte with offset 0
				//               getItemIdentifier returned value = getValueByte returned value
				testCaseNb = (byte) 4 ;

				bRes = false ;
				try {
					envHdlr.findTLV(TAG_DEVICE_IDENTITIES, (byte)1);
					if ( envHdlr.getItemIdentifier() ==  envHdlr.getValueByte((short)0) )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			break;

			case (byte) 4 :
				// --------------------------------------------
				// Test Case 5 : Receive envelope without item identifier TLV and getItemIdentifier
				//               getItemIdentifier must throw ToolkitException (UNAVAILABLE_ELEMENT)
				testCaseNb = (byte) 5 ;

				bRes = false ;
				try {
					envHdlr.getItemIdentifier();
					bRes = false;
				}
				catch (ToolkitException e)    {    
					if (e.getReason() == ToolkitException.UNAVAILABLE_ELEMENT )
						bRes = true;
					
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			break;

			case (byte) 5 :
				// --------------------------------------------
				// Test Case 6 : Receive envelope with item identifier TLV (66), send proactive command. Then getItemIdentifier
				//               method must return 66
				testCaseNb = (byte) 6 ;

				bRes = false ;
				try {
					proHdlr.initDisplayText((byte)0x80, DCS_8_BIT_DATA, displayString, (short) 0, (short) displayString.length);
					proHdlr.send();
					if (envHdlr.getItemIdentifier() == (byte) 0x66)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			break;

			case (byte) 6 :
				// --------------------------------------------
				// Test Case 7 : Receive envelope with item identifier TLV but without item number, send proactive command.
				testCaseNb = (byte) 7 ;

				bRes = false ;
				try {
					if (envHdlr.getItemIdentifier() == (byte) 0x00)
						bRes = false;
				}
				catch (ToolkitException e)    {    
					if (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;

			break;
		}
	}
}
