//-----------------------------------------------------------------------------
//    API_2_ENH_GSDO_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_gsdo;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeHandler.getSecuredDataOffset()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_ENH_GSDO_1  extends TestToolkitApplet
{

    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public API_2_ENH_GSDO_1 () 
    {
		// Set Formatted SMS PP UPD as an activation event for the applet
        obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
		
		// Set Formatted SMS CB as an activation event for the applet
        obReg.setEvent(EVENT_FORMATTED_SMS_CB);

		// Set Unformatted SMS CB as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);

		// Set Unformatted SMS PP as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_GSDO_1  thisApplet = new API_2_ENH_GSDO_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    switch ( testCaseNb ) 
		{
		    //=================================================================
		    //=========        FORMATTED SMS PP ENV triggering        =========
		    //=================================================================
			case (byte) 0 :
				// --------------------------------------------
				// Test Case 1 : getSecuredDataOffset with various length of TP-OA:2
				testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x21)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 1 :
				// --------------------------------------------
				// Test Case 2 : getSecuredDataOffset with various length of TP-OA:6
				testCaseNb = (byte) 2 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x23)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 2 :
				// --------------------------------------------
				// Test Case 3 : getSecuredDataOffset with various length of TP-OA:12
				testCaseNb = (byte) 3 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x26)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 3 :
				// --------------------------------------------
				// Test Case 4 : getSecuredDataOffset with various length of RC/CC/DS:0 
				testCaseNb = (byte) 4 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x21)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 4 :
				// --------------------------------------------
				// Test Case 5 : getSecuredDataOffset with various length of RC/CC/DS:8
				testCaseNb = (byte) 5 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x29)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 5 :
				// --------------------------------------------
				// Test Case 6 : getSecuredDataOffset when the SMS PP contains 2 TLV
				testCaseNb = (byte) 6 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x24)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 6 :
				// --------------------------------------------
				// Test Case 7 : getSecuredDataOffset without secured data
				testCaseNb = (byte) 7 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x21)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 7 :
				// --------------------------------------------
				// Test Case 8 : findTLV device Identities (Formatted SMS PP envelope)
				testCaseNb = (byte) 8 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getSecuredDataOffset() == 0x24)&&
						(envHdlr.getValueByte((short)0)==0x40))
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 8 :
				// --------------------------------------------
				// Test Case 9 : Concatenated SMS with maximum secured data length (0xFA)
				testCaseNb = (byte) 9 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x21)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			

		    //=================================================================
		    //=========        FORMATTED SMS PP UPD triggering        =========
		    //=================================================================
			case (byte) 9 :
				// --------------------------------------------
				// Test Case 10 : getSecuredDataOffset with various length of TP-OA:2
				testCaseNb = (byte) 10 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x21)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 10 :
				// --------------------------------------------
				// Test Case 11 : getSecuredDataOffset with various length of TP-OA:6
				testCaseNb = (byte) 11 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x23)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 11 :
				// --------------------------------------------
				// Test Case 12 : getSecuredDataOffset with various length of TP-OA:12
				testCaseNb = (byte) 12 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x26)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 12 :
				// --------------------------------------------
				// Test Case 13 : getSecuredDataOffset with various length of RC/CC/DS:0 
				testCaseNb = (byte) 13 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x21)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 13 :
				// --------------------------------------------
				// Test Case 14 : getSecuredDataOffset with various length of RC/CC/DS:8
				testCaseNb = (byte) 14 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x29)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 14 :
				// --------------------------------------------
				// Test Case 15 : getSecuredDataOffset when the SMS PP contains 2 TLV
				testCaseNb = (byte) 15 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x24)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		
			case (byte) 15 :
				// --------------------------------------------
				// Test Case 16 : getSecuredDataOffset without secured data
				testCaseNb = (byte) 16 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x21)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 16 :
				// --------------------------------------------
				// Test Case 17 : findTLV device Identities (Formatted SMS PP UPD)
				testCaseNb = (byte) 17 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getSecuredDataOffset() == 0x21)&&
						(envHdlr.getValueByte((short)0)==0x40))
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

				
			case (byte) 17 :
				// --------------------------------------------
				// Test Case 18 : Concatenated SMS with maximum secured data length (0xFA)
				testCaseNb = (byte) 18 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x21)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
		    //=================================================================
		    //=========          FORMATTED SMS CB triggering          =========
		    //=================================================================
			case (byte) 18 :
				// --------------------------------------------
				// Test Case 19 : getSecuredDataOffset with various length of RC/CC/DS:0 
				testCaseNb = (byte) 19 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x16)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 19 :
				// --------------------------------------------
				// Test Case 20 : getSecuredDataOffset with various length of RC/CC/DS:8
				testCaseNb = (byte) 20 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x1E)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 20 :
				// --------------------------------------------
				// Test Case 21 : getSecuredDataOffset without secured data
				testCaseNb = (byte) 21 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataOffset() == 0x16)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 21 :
				// --------------------------------------------
				// Test Case 22 : findTLV device Identities (Formatted SMS CB envelope)
				testCaseNb = (byte) 22 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getSecuredDataOffset() == 0x16)&&
						(envHdlr.getValueByte((short)0)==0x00))
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

	
		    //=================================================================
		    //=========             UNFORMATTED triggering            =========
		    //=================================================================
			case (byte) 22 :
				// --------------------------------------------
				// Test Case 23 : try to apply the getSecuredDataOffset method on an Unformatted SMS CB envelope
				testCaseNb = (byte) 23 ;

				bRes = false ;
				try {
					short returnvalue = envHdlr.getSecuredDataOffset();
				}
				catch (ToolkitException e)    {
					if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT) 
						bRes = true ;
					else
						bRes = false ;
				}
				catch (Exception e)    {    
						bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 23 :
				// --------------------------------------------
				// Test Case 24 : try to apply the getSecuredDataOffset method on an Unformatted SMS PP envelope
				testCaseNb = (byte) 24 ;

				bRes = false ;
				try {
					short returnvalue = envHdlr.getSecuredDataOffset();
				}
				catch (ToolkitException e)    {
					if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT) 
						bRes = true ;
					else
						bRes = false ;
				}
				catch (Exception e)    {    
						bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		}
	}
}
