//-----------------------------------------------------------------------------
//    API_2_ERH_CPYVS_BSS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_erh_cpyvs_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.EnvelopeResponseHandler.copyValue(short, byte[], short, short) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 1.0.0 - 01/08/01
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.EnvelopeResponseHandler
 */
public class API_2_ERH_CPYVS_BSS_1 extends TestToolkitApplet {

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;


    /**
     * Constructor of the applet
     */
    public API_2_ERH_CPYVS_BSS_1() {
        // Specific registration to Unrecognized Envelope
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) {
        // Create a new applet instance
        API_2_ERH_CPYVS_BSS_1 thisApplet = new API_2_ERH_CPYVS_BSS_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();
    }


    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;

        // Number of tests
        byte testCaseNb = (byte) 0x00 ;
        
        // Get the system instance of the EnvelopeResponseHandler class
        EnvelopeResponseHandler EnvRespHdlr = EnvelopeResponseHandler.getTheHandler() ;

        // --------------------------------------------
        // Test Case 1 : Null as dstBuffer
        testCaseNb = (byte) 1 ;
        bRes = false ;
        
        byte[] dstBuffer = new byte[5] ;

        byte[] SMS_TPDU_Value2=new byte[16];

        //initialize the buffer
        for(short i=0;i<16;i++)
            SMS_TPDU_Value2[i]=(byte)i;

        //built the first tlv
        EnvRespHdlr.appendTLV((byte)0x0D,SMS_TPDU_Value2,(short) 0x00, (short) 16);

        // Select Text String TLV
        EnvRespHdlr.findTLV((byte)0x0D, (byte)1) ;

        try {
            EnvRespHdlr.copyValue((short)0, null, (short)0, (short)1) ;
        }
        catch (NullPointerException e) {
            bRes = true ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 2 : dstOffset >= dstBuffer.length
        testCaseNb = (byte) 2 ;
        bRes = false ;

        try {
            EnvRespHdlr.copyValue((short)0, dstBuffer, (short)5, (short)1) ;
        }
        catch (ArrayIndexOutOfBoundsException e) {
            bRes = true ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 3 : dstOffset < 0
        testCaseNb = (byte) 3 ;
        bRes = false ;

        try {
            EnvRespHdlr.copyValue((short)0, dstBuffer, (short)-1, (short)1) ;
        }
        catch (ArrayIndexOutOfBoundsException e) {
            bRes = true ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 4 : dstLength > dstBuffer.length
        testCaseNb = (byte) 4 ;
        bRes = false ;

        try {
            EnvRespHdlr.copyValue((short)0, dstBuffer, (short)0, (short)6) ;
        }
        catch (ArrayIndexOutOfBoundsException e) {
            bRes = true ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 5 : dstOffset + dstLength > dstBuffer.length
        testCaseNb = (byte) 5 ;
        bRes = false ;

        try {
            EnvRespHdlr.copyValue((short)0, dstBuffer, (short)3, (short)3) ;
        }
        catch (ArrayIndexOutOfBoundsException e) {
            bRes = true ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 6 : dstLength < 0

        testCaseNb = (byte) 6 ;
        bRes = false ;

        try {
            EnvRespHdlr.copyValue((short)0, dstBuffer, (short)0, (short)-1) ;
        }
        catch (ArrayIndexOutOfBoundsException e) {
            bRes = true ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 7 : valueOffset >= Text String Length
        testCaseNb = (byte) 7 ;
        bRes = false ;

        dstBuffer = new byte[15] ;

        //built the first tlv
        EnvRespHdlr.clear();
        EnvRespHdlr.appendTLV((byte)0x0D,SMS_TPDU_Value2,(short) 0x00, (short) 6);
        EnvRespHdlr.findTLV((byte)0x0D, (byte)1) ;

        try {
            EnvRespHdlr.copyValue((short)6, dstBuffer, (short)0, (short)1) ;
        }
        catch (ToolkitException e) {
            bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 8 : valueOffset < 0
        testCaseNb = (byte) 8 ;
        bRes = false ;

        try {
            EnvRespHdlr.copyValue((short)-1, dstBuffer, (short)0, (short)1) ;
        }
        catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 9 : dstLength > Text String length
        testCaseNb = (byte) 9 ;
        bRes = false ;

        try {
            EnvRespHdlr.copyValue((short)0, dstBuffer, (short)0, (short)7) ;
        }
        catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 10 : valueOffset + dstLength > Text String length
        testCaseNb = (byte) 10 ;
        bRes = false ;

        try {
            EnvRespHdlr.copyValue((short)2, dstBuffer, (short)0, (short)5) ;
        }
        catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 11 : Unavailable element (the envelopeResponseHandler is cleared)
        testCaseNb = (byte) 11 ;
        bRes = false ;

        EnvRespHdlr.clear() ;

        try {
            EnvRespHdlr.copyValue((short)0, dstBuffer, (short)0, (short)1) ;
        }
        catch (ToolkitException e) {
            bRes = (e.getReason() == ToolkitException.UNAVAILABLE_ELEMENT) ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 12 : Successfull call
        testCaseNb = (byte) 12 ;
        bRes = false ;

        dstBuffer = new byte[17] ;

        EnvRespHdlr.appendTLV((byte)0x0D,(byte)4,SMS_TPDU_Value2,(short) 0x00, (short) 0x10);

        // Search Text String TLV
        EnvRespHdlr.findTLV((byte)0x0D, (byte)0x01) ;

        try {
            // Copy TLV
            if(EnvRespHdlr.copyValue((short)0, dstBuffer, (short)0, (short)17)==(short)17)
                bRes = true ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 13 : Compare buffer
        testCaseNb = (byte) 13 ;
        bRes = false ;

        byte[] compareBuffer = new byte[20] ;

        // Initialise compare buffer
        compareBuffer[0] = 4;
        for (short i=1; i<17; i++)
            compareBuffer[i] = (byte)(i-1) ;

        try {
            if(Util.arrayCompare(dstBuffer, (short)0, compareBuffer, (short)0, (short)17)==0)
                bRes=true;
        }    
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 14 : Successfull call
        testCaseNb = (byte) 14 ;
        bRes = false ;

        dstBuffer = new byte[20] ;
        //initialise the destination array
        Util.arrayFillNonAtomic(dstBuffer,(short)0,(short)20,(byte)0x55);

        try {
            // Copy TLV
            if(EnvRespHdlr.copyValue((short)2, dstBuffer, (short)3, (short)12)==15)
                bRes = true ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 15 : Compare buffer
        testCaseNb = (byte) 15 ;
        bRes = false ;

        // Initialise compare buffer
        Util.arrayFillNonAtomic(compareBuffer,(short)0,(short)20,(byte)0x55);
        Util.arrayCopy(SMS_TPDU_Value2, (short)1, compareBuffer, (short)3, (short)12);

        try {
            if(Util.arrayCompare(dstBuffer, (short)0, compareBuffer, (short)0, (short)20)==0)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 16 : Successfull call(with the length = 0 and the offset = length of the destination buffer)
        testCaseNb = (byte) 16 ;
        bRes = false ;

        try {
            // Copy TLV
            if(EnvRespHdlr.copyValue((short)2, dstBuffer, (short)dstBuffer.length, (short)0)==dstBuffer.length)
                bRes = true ;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 17 : ToolkitException HANDLER_NO_AVAILABLE
        testCaseNb = (byte) 17 ;
        bRes = false ;

        try {
            EnvRespHdlr.clear();
            EnvRespHdlr.post((byte)SW1_RP_ACK);
            try {
                EnvRespHdlr.copyValue((short)0, dstBuffer, (short)0, (short)0);
            }
            catch (ToolkitException e) {
                if (e.getReason() == ToolkitException.HANDLER_NOT_AVAILABLE) {
                    bRes= true;
                } else {
                    bRes=false;
                }
            }
        }
        catch (Exception e) {
            bRes = false;
        }
        reportTestOutcome(testCaseNb, bRes) ;
    }
}
