//-----------------------------------------------------------------------------
//    API_2_ERH_FACRBBS_BSS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_erh_facrbbs_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.EnvelopeResponseHandler.findAndCompareValue(byte, byte, short, byte[], short, short) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 1.0.0 - 01/08/01
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.EnvelopeResponseHandler
 */
public class API_2_ERH_FACRBBS_BSS_1 extends TestToolkitApplet {

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;

    /**
     * Constructor of the applet
     */
    public API_2_ERH_FACRBBS_BSS_1() {
        // Specific registration to Unrecognized Envelope
        obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) {
        // Create a new applet instance
        API_2_ERH_FACRBBS_BSS_1 thisApplet = new API_2_ERH_FACRBBS_BSS_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();
    }


    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) {
        // Result of tests
        boolean bRes ;

        // Number of tests
        byte testCaseNb = (byte) 0x00 ;
        
        // Get the system instance of the EnvelopeResponseHandler class
        EnvelopeResponseHandler EnvRespHdlr = EnvelopeResponseHandler.getTheHandler() ;

        // --------------------------------------------
        // Test Case 1 : Null as compareBuffer
        testCaseNb = (byte) 1 ;
        bRes = false ;

        byte[] compareBuffer5=new byte[5];
        byte[] TLVBuffer=new byte[20];

        try {
            // initialise the buffer
            for(short i=1;i<17;i++)
                TLVBuffer[i]=(byte)(i-1);
            TLVBuffer[0]=(byte)4;

            //built the first tlv
            EnvRespHdlr.appendTLV((byte)0x0D,TLVBuffer,(short) 0x00, (short) 17);

            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte) 1, (short) 0, null, (short) 0, (short) 1) ;
            }
            catch (NullPointerException e) {
                bRes = true ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 2 : compareOffset >= compareBuffer.length
        testCaseNb = (byte) 2 ;
        bRes = false ;

        try {
            
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0, compareBuffer5, (short)5, (short)1) ;
            }
            catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 3 : compareOffset < 0
        testCaseNb = (byte) 3 ;
        bRes = false ;
        
        try {
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0, compareBuffer5, (short)-1, (short)1) ;
            }
            catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 4 : compareLength > compareBufferLength
        testCaseNb = (byte) 4 ;
        bRes = false ;

        try {
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0, compareBuffer5, (short)0, (short)6) ;
            }
            catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 5 : compareOffset + compareLength > compareBuffer.length
        testCaseNb = (byte) 5 ;
        bRes = false ;

        try {
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0, compareBuffer5, (short)3, (short)3) ;
            }
            catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 6 : compareLength < 0
        testCaseNb = (byte) 6 ;
        bRes = false ;

        try {
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0 , compareBuffer5, (short)0 , (short)-1) ;
            }
            catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 7 : valueOffset >= Text String Length
        testCaseNb = (byte) 7 ;
        bRes = false ;

        byte[] compareBuffer15=new byte[15];
        try {

            // initialise the buffer
            for(short i=1;i<17;i++)
                TLVBuffer[i]=(byte)(i-1);
            TLVBuffer[0]=(byte)4;

            //built the first tlv
            EnvRespHdlr.clear();
            EnvRespHdlr.appendTLV((byte)0x0D,TLVBuffer,(short) 0x00, (short) 6);

            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)6, compareBuffer15, (short)0, (short)1) ;
            }
            catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 8 : valueOffset < 0
        testCaseNb = (byte) 8 ;
        bRes = false ;

        try {
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)-1, compareBuffer15, (short)0, (short)1) ;
            }
            catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 9 : compareLength > Text String length
        testCaseNb = (byte) 9 ;
        bRes = false ;

        try {
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0, compareBuffer15, (short)0, (short)7) ;
            }
            catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 10 : valueOffset + compareLength > Text String Length
        testCaseNb = (byte) 10 ;
        bRes = false ;

        try {
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)2, compareBuffer15, (short)0, (short)5) ;
            }
            catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 11 : Invalid parameter
        testCaseNb = (byte) 11 ;
        bRes = false ;

        try {
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)0, (short)0, compareBuffer15, (short)0, (short)1) ;
            }
            catch (ToolkitException e) {
                bRes = (e.getReason()==ToolkitException.BAD_INPUT_PARAMETER) ;
            }
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 12 : Unavailable Element
        testCaseNb = (byte) 12 ;
        bRes = false ;

        // Initialise the handler
        EnvRespHdlr.appendTLV((byte)0x02,TLVBuffer,(short) 0x00, (short) 2);
    
        // Select a TLV
        EnvRespHdlr.findTLV(TAG_DEVICE_IDENTITIES, (byte)1) ;

        // FindAndCompareValue
        try {
            EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)2, (short)0, compareBuffer15, (short)0, (short)1) ;
        }
        catch (ToolkitException e) {
            bRes = (e.getReason()==ToolkitException.UNAVAILABLE_ELEMENT) ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 13 : verify the current TLV
        testCaseNb = (byte) 13 ;
        bRes = false ;

        // Verify there is no selected TLV
        try {
            EnvRespHdlr.getValueLength() ;
        }
        catch (ToolkitException e) {
            bRes = (e.getReason()==ToolkitException.UNAVAILABLE_ELEMENT) ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 14 : Successful call
        testCaseNb = (byte) 14 ;
        bRes = false ;

        byte[] compareBuffer17=new byte[17];

        try {

            // initialise the buffer
            for(short i=1;i<17;i++) {
                compareBuffer17[i]=(byte)(i-1);
                TLVBuffer[i]=(byte)(i-1);
            }
            TLVBuffer[0]=(byte)4;
            compareBuffer17[0]=(byte)4;

            //built the first tlv
            EnvRespHdlr.clear();
            EnvRespHdlr.appendTLV((byte)0x0D,TLVBuffer,(short) 0x00, (short) 17);

            if(EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0, compareBuffer17, (short)0, (short)17)==0)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 15 : Verify current TLV
        testCaseNb = (byte) 15 ;
        bRes = false ;

        try {
            if(EnvRespHdlr.getValueLength()==(short)17)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 16 : Successful call
        testCaseNb = (byte) 16;
        bRes = false ;

        try {
            // Initialise buffers
            compareBuffer17[16] = 0x10 ;

            if(EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0, compareBuffer17, (short)0, (short)17)==-1)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 17 : Successful call
        testCaseNb = (byte) 17;
        bRes = false ;

        try {
            // Initialise buffers
            compareBuffer17[16] = 0x0F ;
            compareBuffer17[0] = 0x03 ;
                                    
            if(EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0, compareBuffer17, (short)0, (short)17)==+1)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 18 : Successful call
        testCaseNb = (byte) 18;
        bRes = false ;

        try {
            // Initialise buffers
            Util.arrayFillNonAtomic(TLVBuffer,(short)0,(short)TLVBuffer.length,(byte)0x55);
            for(short i=3;i<15;i++)
                TLVBuffer[i]=(byte)(i-2);
            
            if(EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)2, TLVBuffer, (short)3, (short)12)==0)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 19 : Successful call
        testCaseNb = (byte) 19;
        bRes = false ;

        try {
            // Initialise buffers
            TLVBuffer[3]=(byte)0x02 ;
            TLVBuffer[4]=(byte)0x01 ;
                                    
            if(EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)2, TLVBuffer, (short)3, (short)12)==-1)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 20 : Successful call
        testCaseNb = (byte) 20;
        bRes = false ;

        try {
            // Initialise buffers
            TLVBuffer[3]=(byte)0x01 ;
            TLVBuffer[4]=(byte)0x02 ;
            TLVBuffer[13]=(byte)0x0A ;
            TLVBuffer[14]=(byte)0x0D ;
                                    
            if(EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)2, TLVBuffer, (short)3, (short)12)==+1)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 21 : Successful call
        testCaseNb = (byte)21 ;
        bRes = false ;

        try {

            // Append a 2nd Text String TLV
            TLVBuffer[0] = (byte)0x00 ;
            TLVBuffer[1] = (byte)0x11 ;
            TLVBuffer[2] = (byte)0x22 ;
            TLVBuffer[3] = (byte)0x33 ;
            TLVBuffer[4] = (byte)0x44 ;
            TLVBuffer[5] = (byte)0x55 ;

            EnvRespHdlr.appendTLV((byte)0x0D, TLVBuffer, (short)0, (short)6) ;

            // initialise the buffer
            for(short i=1;i<17;i++) {
                compareBuffer17[i]=(byte)(i-1);
                TLVBuffer[i]=(byte)(i-1);
            }
            TLVBuffer[0]=(byte)4;

            if(EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)1, (short)0, TLVBuffer, (short)0, (short)17)==0)
                bRes=true;    
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 22 : Successful call
        testCaseNb = (byte)22 ;
        bRes = false ;

        try {

            // Append a 2nd Text String TLV
            TLVBuffer[0] = (byte)0x00 ;
            TLVBuffer[1] = (byte)0x11 ;
            TLVBuffer[2] = (byte)0x22 ;
            TLVBuffer[3] = (byte)0x33 ;
            TLVBuffer[4] = (byte)0x44 ;
            TLVBuffer[5] = (byte)0x55 ;

            if(EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)2, (short)0, TLVBuffer, (short)0, (short)6)==0)
                bRes=true;    
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 23 : Successful call
        testCaseNb = (byte)23 ;
        bRes = false ;

        try {
            // Initialise buffers
            TLVBuffer[5] = (byte)0x66 ;
                                    
            if(EnvRespHdlr.findAndCompareValue((byte)0x0D, (byte)2, (short)0, TLVBuffer, (short)0, (short)6)==-1)
                bRes=true;    
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 24 : Successful call : search tag 8Dh
        testCaseNb = (byte) 24 ;
        bRes = false ;

        try {
            // initialise the buffer
            for(short i=1;i<17;i++) 
                TLVBuffer[i]=(byte)(i-1);
            TLVBuffer[0]=(byte)4;

            EnvRespHdlr.clear();
            EnvRespHdlr.appendTLV((byte)0x0D, TLVBuffer, (short)0, (short)17) ;

            if(EnvRespHdlr.findAndCompareValue((byte)0x8D, (byte)1, (short)0, TLVBuffer, (short)0, (short)17)==0)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 25 : Successful call : search tag 8Fh
        testCaseNb = (byte) 25 ;
        bRes = false ;

        byte[] compareBuffer16=new byte[16];

        try {
            // Append tag 0Fh
            EnvRespHdlr.appendTLV((byte)0x0F, TLVBuffer, (short)1, (short)16) ;
            
            for(short i=0;i<16;i++) 
                TLVBuffer[i]=TLVBuffer[(short)(i+1)];
            
            if(EnvRespHdlr.findAndCompareValue((byte)0x8F, (byte)1, (short)0, TLVBuffer, (short)0, (short)16)==0)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 26 : Successful call (with the length = 0 and the offset = length of the comparaison buffer)
        testCaseNb = (byte) 26 ;
        bRes = false ;

        try {
            if(EnvRespHdlr.findAndCompareValue((byte)0x8F, (byte)1, (short)0, TLVBuffer, (short)TLVBuffer.length, (short)0)==0)
                bRes=true;
        }
        catch (Exception e) {
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 27 : ToolkitException HANDLER_NOT_AVAILABLE
        testCaseNb = (byte) 27 ;
        bRes = false ;

        try {
            EnvRespHdlr.clear();
            EnvRespHdlr.post((byte)SW1_RP_ACK);
            try {
                EnvRespHdlr.findAndCompareValue((byte)0x8F, (byte)1, (short)0, TLVBuffer, (short)0x0F, (short)0);
            }
            catch (ToolkitException e) {
                if (e.getReason() == ToolkitException.HANDLER_NOT_AVAILABLE) {
                    bRes = true;
                } else {
                    bRes = false;
                }
            }
        }
        catch (Exception e) {
            bRes = false;
        }
        reportTestOutcome(testCaseNb, bRes) ;
    }
}
