//-----------------------------------------------------------------------------
//    API_2_PAH_ICCHB_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_pah_icchb;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.framework Toolkit Installation, Channels Allocation
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 */
public class API_2_PAH_ICCHB_1 extends TestToolkitApplet {

    public final static byte CHANNEL_ID1 = (byte)0x01;
    public final static byte CHANNEL_ID2 = (byte)0x02;
    public final static byte QUALIFIER_1 = (byte)0x01;
    public static byte[] ADDRESS_VALUE = {(byte)0x81, (byte)0x55, (byte)0x66, (byte)0x77, (byte)0x88};
    public static byte[] BEARER_VALUE = {(byte)0x03, (byte)0x00};
    public static byte[] BUFFER_SIZE_VALUE = {(byte)0x00, (byte)0x0A};

    // Number of tests
    byte testCaseNb = (byte)0;

    /**
     * Constructor of the applet
     */
    public API_2_PAH_ICCHB_1() {
        obReg.setEvent(EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS);
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) {

        // Create a new applet instance
        API_2_PAH_ICCHB_1 thisApplet = new API_2_PAH_ICCHB_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();

    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) {
        
        // Result of each test
        boolean bRes = false ;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler();

        if (event == EVENT_FORMATTED_SMS_PP_ENV) {
            // Open a channel
            proHdlr.init(PRO_CMD_OPEN_CHANNEL, QUALIFIER_1, DEV_ID_ME);
            proHdlr.appendTLV(TAG_ADDRESS, ADDRESS_VALUE, (short)0, (short)5);
            proHdlr.appendTLV(TAG_BEARER_DESCRIPTION, BEARER_VALUE, (short)0, (short)2);
            proHdlr.appendTLV(TAG_BUFFER_SIZE, BUFFER_SIZE_VALUE, (short)0, (short)2);
            proHdlr.send();
        }

        
	    if (event == EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS) {
            switch(testCaseNb) {
                case (byte)0 :
                    // --------------------------------------------
                    // Test Case 1 : initCloseChannel
                    testCaseNb = (byte) 1 ;
                    try {
                        proHdlr.initCloseChannel(CHANNEL_ID1);
                        proHdlr.send();
                        bRes = true;
                    }
                    catch (Exception e) {	
			            bRes = false;
		            }
                    reportTestOutcome(testCaseNb, bRes);
                    break;
            
                    // --------------------------------------------
                    // Test Case 2 :
                case (byte)1 :
                    testCaseNb = (byte) 2 ;
                    try {
                        proHdlr.initCloseChannel(CHANNEL_ID2);
                        proHdlr.initCloseChannel(CHANNEL_ID1);
                        proHdlr.send();
                        bRes = true;
                    }
                    catch (Exception e) {	
			            bRes = false;
		            }
                    reportTestOutcome(testCaseNb, bRes);
                    break;

                    // --------------------------------------------
                    // Test Case 3 :
                case (byte)2 :
                    testCaseNb = (byte) 3 ;
                    try {
                        proHdlr.findTLV(TAG_ADDRESS,(byte)1);
                        proHdlr.initCloseChannel(CHANNEL_ID1);
                        short i = proHdlr.getValueLength();
                        bRes = false;
                    }
                    catch (ToolkitException e) {
                        if (e.getReason() == ToolkitException.UNAVAILABLE_ELEMENT) {
                            bRes = true;
                        }
                    }
                    catch (Exception e) {
                        bRes = false;
                    }
                    try {
                        proHdlr.send();
                    }
                    catch (Exception e) {}
                    reportTestOutcome(testCaseNb, bRes);
                    break;

                    // --------------------------------------------
                    // Test Case 4 :
                case (byte)3 :
                    testCaseNb = (byte) 4 ;
                    try {
                        proHdlr.initCloseChannel(CHANNEL_ID1);
                        bRes = true;
                    }
                    catch (Exception e) {	
			            bRes = false;
		            }
                    reportTestOutcome(testCaseNb, bRes);
                    break;
            }

	    }
    }
}
