//-----------------------------------------------------------------------------
//    API_2_PRH_CPYVS_BSS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_prh_cpyvs_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ProactiveResponseHandler.copyValue(short, byte[], short, short) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.2 - 07/12/00
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.ProactiveResponseHandler
 */
public class API_2_PRH_CPYVS_BSS_1 extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;

    private byte[] TEXT = {(byte)'T',(byte)'e',(byte)'x',(byte)'t'} ;
    
    private byte[] dstBuffer5 = new byte[5] ;
    private byte[] dstBuffer15 = new byte[15] ;
    private byte[] dstBuffer17 = new byte[17] ;
    private byte[] dstBuffer20 = new byte[20] ;
    private byte[] compareBuffer = new byte[20] ;
    
    /**
     * Constructor of the applet
     */
    public API_2_PRH_CPYVS_BSS_1() 
    {

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_PRH_CPYVS_BSS_1 thisApplet = new API_2_PRH_CPYVS_BSS_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Number of tests
        byte testCaseNb = (byte) 0x00 ;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        ProactiveResponseHandler proRespHdlr = null ;
        
        // Result of method
        short result = 0 ;

        short valueOffset = 0 ;
        short dstOffset = 0 ;
        short dstLength = 0 ;
        
        
        // --------------------------------------------
        // Test Case 1 : Null as dstBuffer
        testCaseNb = (byte) 1 ;
        bRes = false ;
        
        try {
            
            // Send a GET INPUT command
            proHdlr.initGetInput((byte)0, DCS_8_BIT_DATA, TEXT, (short)0, (short)TEXT.length, (short)0, (short)0xFF) ;
            proHdlr.send() ;
            
            // Get the response
            proRespHdlr = ProactiveResponseHandler.getTheHandler() ;
            
            // Select Text String TLV
            proRespHdlr.findTLV(TAG_TEXT_STRING, (byte)1) ;
            
            try {
                valueOffset = (short)0 ;
                dstOffset = (short)0 ;
                dstLength = (short)1 ;
                proRespHdlr.copyValue(valueOffset, null, dstOffset, dstLength) ;
                
            } catch (NullPointerException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 2 : dstOffset > dstBuffer.length
        testCaseNb = (byte) 2 ;
        bRes = false ;
        
        try {
                        
            valueOffset = (short)0 ;
            dstOffset = (short)7 ;
            dstLength = (short)0 ;
            
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer5, dstOffset, dstLength) ;
                
            } catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 3 : dstOffset < 0
        testCaseNb = (byte) 3 ;
        bRes = false ;
        
        try {
            
            valueOffset = (short)0 ;
            dstOffset = (short)-1 ;
            dstLength = (short)1 ;
            
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer5, dstOffset, dstLength) ;
                
            } catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 4 : dstLength > dstBuffer.length
        testCaseNb = (byte) 4 ;
        bRes = false ;
        
        try {
            
            valueOffset = (short)0 ;
            dstOffset = (short)0 ;
            dstLength = (short)6 ;
            
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer5, dstOffset, dstLength) ;
                
            } catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 5 : dstOffset + dstLength > dstBuffer.length
        testCaseNb = (byte) 5 ;
        bRes = false ;
        
        try {
            
            valueOffset = (short)0 ;
            dstOffset = (short)3 ;
            dstLength = (short)3 ;
            
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer5, dstOffset, dstLength) ;
                
            } catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 6 : dstLength < 0
        testCaseNb = (byte) 6 ;
        bRes = false ;
        
        try {
            
            valueOffset = (short)0 ;
            dstOffset = (short)0 ;
            dstLength = (short)-1 ;
            
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer5, dstOffset, dstLength) ;
                
            } catch (ArrayIndexOutOfBoundsException e) {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 7 : valueOffset > Text String Length
        testCaseNb = (byte) 7 ;
        bRes = false ;
        
        try {
            
            valueOffset = (short)7 ;
            dstOffset = (short)0 ;
            dstLength = (short)0 ;
                        
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer15, dstOffset, dstLength) ;
                
            } catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 8 : valueOffset < 0
        testCaseNb = (byte) 8 ;
        bRes = false ;
        
        try {
                        
            valueOffset = (short)-1 ;
            dstOffset = (short)0 ;
            dstLength = (short)1 ;
                        
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer15, dstOffset, dstLength) ;
                
            } catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 9 : dstLength > Text String length
        testCaseNb = (byte) 9 ;
        bRes = false ;
        
        try {
                        
            valueOffset = (short)0 ;
            dstOffset = (short)0 ;
            dstLength = (short)7 ;
                        
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer15, dstOffset, dstLength) ;
                
            } catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 10 : valueOffset + dstLength > Text String length
        testCaseNb = (byte) 10 ;
        bRes = false ;
        
        try {
                        
            valueOffset = (short)2 ;
            dstOffset = (short)0 ;
            dstLength = (short)5 ;
                        
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer15, dstOffset, dstLength) ;
                
            } catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 11 : Unavailable element
        testCaseNb = (byte) 11 ;
        bRes = false ;
        
        try {
                        
            // Send a GET INPUT command
            proHdlr.initGetInput((byte)0, DCS_8_BIT_DATA, TEXT, (short)0, (short)TEXT.length, (short)0, (short)0xFF) ;
            proHdlr.send() ;
            
            // Get the response
            proRespHdlr = ProactiveResponseHandler.getTheHandler() ;
                                   
            valueOffset = (short)0 ;
            dstOffset = (short)0 ;
            dstLength = (short)1 ;
                        
            try {
                proRespHdlr.copyValue(valueOffset, dstBuffer15, dstOffset, dstLength) ;
                
            } catch (ToolkitException e) {
                bRes = (e.getReason() == ToolkitException.UNAVAILABLE_ELEMENT) ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 12 : Successfull call
        testCaseNb = (byte) 12 ;
        bRes = false ;

        // Initialise dstBuffer
        for (short i=0; i<dstBuffer17.length; i++) {
            dstBuffer17[i] = (byte)0x55 ;
        }
        
        try {
            
            // Search Text String TLV
            proRespHdlr.findTLV(TAG_TEXT_STRING, (byte)0x01) ;
            
            // Copy TLV
            valueOffset = (short)0 ;
            dstOffset = (short)0 ;
            dstLength = (short)17 ;
            result = proRespHdlr.copyValue(valueOffset, dstBuffer17, dstOffset, dstLength) ;

            bRes = (result == (short)17) ;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 13 : Compare buffer
        testCaseNb = (byte) 13 ;
        bRes = false ;

        // Initialise compare buffer
        for (short i=0; i<compareBuffer.length; i++) {
            compareBuffer[i] = (byte)0x55 ;
        }
        compareBuffer[0] = DCS_8_BIT_DATA ;
        for (short i=1; i<17; i++) {
            compareBuffer[i] = (byte)(i-1) ;
        }
                
        try {
                        
            result = javacard.framework.Util.arrayCompare(dstBuffer17, (short)0, compareBuffer, (short)0, (short)17) ;

            bRes = (result == (byte)0) ;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 14 : Successfull call
        testCaseNb = (byte) 14 ;
        bRes = false ;
        
        // Initialise dstBuffer
        for (short i=0; i<dstBuffer20.length; i++) {
            dstBuffer20[i] = (byte)0x55 ;
        }
        
        try {
                        
            // Search Text String TLV
            proRespHdlr.findTLV(TAG_TEXT_STRING, (byte)0x01) ;
            
            // Copy TLV
            valueOffset = (short)2 ;
            dstOffset = (short)3 ;
            dstLength = (short)12 ;
            result = proRespHdlr.copyValue(valueOffset, dstBuffer20, dstOffset, dstLength) ;

            bRes = (result == (short)15) ;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        
        // --------------------------------------------
        // Test Case 15 : Compare buffer
        testCaseNb = (byte) 15 ;
        bRes = false ;

        // Initialise compare buffer
        for (short i=0; i<compareBuffer.length; i++) {
            compareBuffer[i] = (byte)0x55 ;
        }
        for (short i=(short)3; i<15; i++) {
            compareBuffer[i] = (byte)(i-2) ;
        }
                
        try {
                        
            result = javacard.framework.Util.arrayCompare(dstBuffer20, (short)0, compareBuffer, (short)0, (short)20) ;

            bRes = (result == (byte)0) ;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

 
    }
}
